/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.iterate.conf 17695 2009-07-21 12:22:18Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "teraStation.h"

#include<sys/param.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<unistd.h>
#include<string.h>
#include<time.h>
#include<iconv.h>
#include<ctype.h>
#include <errno.h>

//#define	BUFFALO_CONF_BACKUP_DETAIL_INFO

/** Initializes the teraStation module */
char **errormon;
int errormon_num;
char outputLocale[64];

struct nas_feature {
    long max_disk_num;
    long max_array_num;
    int support_lvm;
    int support_fofb;
	long max_iscsi_num;
	int support_iscsi;
	int support_iscsi_type;
} nas_feature = {
	NUM_NASDISKINFO,
	NUM_NASARRAYINFO,
	0,
	0,
	NUM_NASISCSIINFO_LIMIT,
	0,
	0,
};

void locale_parse_config(const char *token, char *cptr);
char* getValue(char* key, char* buff);

void
init_teraStation(void)
{
    FILE *fp;
    char buff[256], *buffp;
    char *tmp;

    errormon = NULL;
    errormon_num = 0;
    if ((fp = popen("errormon -l | awk '{print $1}'\n", "r")) != NULL) {
	while (fgets(buff, sizeof(buff), fp) != NULL) {
	    if (errormon_num % 5 == 0) {
		errormon = realloc(errormon, (errormon_num + 5) * sizeof(char*));
	    }

	    buffp = &buff[strlen(buff)];
	    while (buffp != buff && isspace((int)*(buffp-1))) {
		    buffp--;
	    }
	    *buffp = '\0';
	    errormon[errormon_num] = strdup(buff);
	    errormon_num++;
	}
	if (!WIFEXITED(pclose(fp))) {
	    errormon = NULL;
	}
    }

    outputLocale[0] = '\0';
    snmpd_register_config_handler("locale", locale_parse_config, NULL,
				  "locale-when-outputting-object");

    if ((fp = fopen(FILE_NASFEATURE, "r")) != NULL) {
	while (fgets(buff, sizeof(buff), fp) != NULL) {
	    buffp = &buff[strlen(buff)];
	    while (buffp != buff && isspace((int)*(buffp-1))) {
		buffp--;
	    }
	    *buffp = '\0';

	    if ((buffp = getValue(LINE_MAXDISKNUM, buff)) != NULL) {
		nas_feature.max_disk_num = strtol(buffp, &tmp, 10);
		if (buffp == tmp || *tmp != '\0' || 
		    nas_feature.max_disk_num < 0 ||
		    nas_feature.max_disk_num > NUM_NASDISKINFO_LIMIT) {
		    nas_feature.max_disk_num = NUM_NASDISKINFO;
		}
	    } else if ((buffp = getValue(LINE_MAXARRAYNUM, buff)) != NULL) {
		nas_feature.max_array_num = strtol(buffp, &tmp, 10);
		if (buffp == tmp || *tmp != '\0' || 
		    nas_feature.max_array_num < 0 ||
		    nas_feature.max_array_num > NUM_NASARRAYINFO_LIMIT) {
		    nas_feature.max_array_num = NUM_NASARRAYINFO;
		}
	    } else if ((buffp = getValue(LINE_SUPPORTLVM, buff)) != NULL) {
		if (strcmp(buffp, "0") != 0) {
		    nas_feature.support_lvm = 1;
		}
	    } else if ((buffp = getValue(LINE_SUPPORTFOFB, buff)) != NULL) {
		if (strcmp(buffp, "0") != 0) {
		    nas_feature.support_fofb = 1;
		}
		} else if ((buffp = getValue(LINE_SUPPORTISCSI, buff)) != NULL) {
			if (strcmp(buffp, "0") != 0) {
			    nas_feature.support_iscsi = 1;
			}
		} else if ((buffp = getValue(LINE_SUPPORTISCSITYPE, buff)) != NULL) {
			if (strcmp(buffp, "RTS") != 0) {
			    nas_feature.support_iscsi_type = 1;
			}
		}
	}
	fclose(fp);
    }

    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_nasBackupTable();
    initialize_table_nasDiskTable();
    initialize_table_nasArrayTable();
    initialize_table_nasErrorTable();
    initialize_table_nasInformationTable();
    initialize_table_nasVGTable();
    initialize_table_nasLVTable();
    initialize_table_nasPVTable();
    init_nasFailoverParams();
    initialize_table_nasRPSUTable();
    initialize_table_nasISCSITable();
    init_nasSystemInformation();
    init_nasServiceStatus();
}

void
locale_parse_config(const char *token, char *cptr)
{
	outputLocale[0] = '\0';
	snprintf(outputLocale, sizeof(outputLocale), "%s", cptr);
}

char*
getValue(char* key, char* buff)
{
    int keylen = strlen(key);
    char* buffp;

    if (strncmp(key, buff, keylen) != 0) {
	return NULL;
    }

    buffp = &buff[keylen];
    while(*buffp == ' ' || *buffp == '\t') {
	buffp++;
    }

    if (*buffp != '=') {
	return NULL;
    }

    buffp++;
    while(*buffp == ' ' || *buffp == '\t') {
	buffp++;
    }

    return buffp;
}

void
convChar(char* src, char* dst, size_t* dstlen, long dstsize)
{
    iconv_t it = iconv_open(outputLocale, "UTF-8");
    size_t inleft = strlen(src), outleft = dstsize;

    if (outputLocale[0] == '\0' || it == (iconv_t)-1) {
	*dstlen = sprintf(dst, "%s", src);
    } else if (iconv(it, &src, &inleft, &dst, &outleft) == -1) {
	dst[0] = '\0';
	*dstlen = 0;
    } else {
	*dstlen = dstsize - outleft;
    }
    
    iconv_close(it);
}

//# Determine the first/last column names

/** Initialize the nasBackupTable table by defining its contents and how it's structured */
struct nasBackupTable_entry *
nasBackupTable_createEntry(long nasBackupIndex, char* nasBackupFile);

void
initialize_table_nasBackupTable(void)
{
    const oid       nasBackupTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 1 };
    const size_t    nasBackupTable_oid_len =
        OID_LENGTH(nasBackupTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasBackupTable\n"));

    reg =
        netsnmp_create_handler_registration("nasBackupTable",
                                            nasBackupTable_handler,
                                            nasBackupTable_oid,
                                            nasBackupTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasBackupIndex */
                                     0);
    table_info->min_column = COLUMN_NASBACKUPNAME;
    table_info->max_column = COLUMN_NASBACKUPFOLDER;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasBackupTable_get_first_data_point;
    iinfo->get_next_data_point = nasBackupTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASBACKUPTASK; i > 0; i--)
	    nasBackupTable_createEntry(i, FILE_NASBACKUPTASK);
}

    /*
     * Typical data structure for a row entry 
     */
struct nasBackupTable_entry {
    /*
     * Index values 
     */
    long            nasBackupIndex;

    char            nasBackupFile[MAXPATHLEN];

    time_t          nasBackupMtime;
    /*
     * Column values 
     */
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
    char            nasBackupName[1024];
    size_t          nasBackupName_len;
#endif
    long            nasBackupStatus;
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
    long            nasBackupTrigger;
    char            nasBackupRunTime[8];
    size_t          nasBackupRunTime_len;
    long            nasBackupRunDOW;
    long            nasBackupRunWeek;
    char            nasBackupFolder[MAXPATHLEN * 2];
    size_t          nasBackupFolder_len;
#endif

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasBackupTable_entry *next;
};

struct nasBackupTable_entry *nasBackupTable_head;

void
nasBackupTable_updateEntry(struct nasBackupTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;

    if ((fp = fopen(entry->nasBackupFile, "r")) == NULL) {
	return;
    }

    while(fgets(buff, sizeof(buff), fp) != NULL){
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
	if((buffp = getValue(LINE_NASBACKUPNAME, buff)) != NULL) {
	    convChar(buffp, entry->nasBackupName, &entry->nasBackupName_len,
		     sizeof(entry->nasBackupName));
	} else
#endif
	if((buffp = getValue(LINE_NASBACKUPSTATUS, buff)) != NULL) {
	    if (strcmp("ready", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_READY;
	    else if (strcmp("run", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_RUN;
	    else if (strcmp("done", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_DONE;
	    else if (strcmp("err", buffp) == 0)
		entry->nasBackupStatus = NASBACKUPSTATUS_ERROR;
	    else
		entry->nasBackupStatus = NASBACKUPSTATUS_NONE;
	}
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
	else if((buffp = getValue(LINE_NASBACKUPTRIGGER, buff)) != NULL) {
	    if (strcmp("now", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_NOW;
	    else if (strcmp("day", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYDAY;
	    else if (strcmp("week", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYWEEK;
	    else if (strcmp("month", buffp) == 0)
		entry->nasBackupTrigger = NASBACKUPTRIGGER_EVERYMONTH;
	    else
		entry->nasBackupTrigger = 0;
	} else if((buffp = getValue(LINE_NASBACKUPTIME, buff)) != NULL) {
	    entry->nasBackupRunTime_len =
		    sprintf(entry->nasBackupRunTime, "%s", buffp);
	} else if((buffp = getValue(LINE_NASBACKUPDOW, buff)) != NULL) {
	    if (strcmp("Sun", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_SUN;
	    else if (strcmp("Mon", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_MON;
	    else if (strcmp("Tue", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_TUE;
	    else if (strcmp("Wed", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_WED;
	    else if (strcmp("Thu", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_THU;
	    else if (strcmp("Fri", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_FRI;
	    else if (strcmp("Sat", buffp) == 0)
		entry->nasBackupRunDOW = NASBACKUPRUNDOW_SAT;
	    else
		entry->nasBackupRunDOW = 0;
	} else if((buffp = getValue(LINE_NASBACKUPWEEK, buff)) != NULL) {
	    if (strcmp("1", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FIRSTWEEK;
	    else if (strcmp("2", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_SECONDWEEK;
	    else if (strcmp("3", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_THIRDWEEK;
	    else if (strcmp("4", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FOURTHWEEK;
	    else if (strcmp("13", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_FIRSTANDTHIRD;
	    else if (strcmp("24", buffp) == 0)
		entry->nasBackupRunWeek = NASBACKUPRUNWEEK_SECONDANDFOURTH;
	    else
		entry->nasBackupRunWeek = 0;
	} else if((buffp = getValue(LINE_NASBACKUPFOLDER, buff)) != NULL) {
	    convChar(buffp, entry->nasBackupFolder, &entry->nasBackupFolder_len,
		     sizeof(entry->nasBackupFolder));
	}
#endif
    }
    fclose(fp);
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasBackupTable_entry *
nasBackupTable_createEntry(long nasBackupIndex, char* nasBackupFile)
{
    struct nasBackupTable_entry *entry;
    struct stat st;

    entry = SNMP_MALLOC_TYPEDEF(struct nasBackupTable_entry);
    if (!entry)
        return NULL;

    entry->nasBackupIndex = nasBackupIndex;
    snprintf(entry->nasBackupFile, MAXPATHLEN,
	     "%s%d",
	     nasBackupFile, nasBackupIndex);
    entry->nasBackupMtime = 0;
    entry->next = nasBackupTable_head;
    nasBackupTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasBackupTable_removeEntry(struct nasBackupTable_entry *entry)
{
    struct nasBackupTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasBackupTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasBackupTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasBackupTable_get_first_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasBackupTable_head;
    return nasBackupTable_get_next_data_point(my_loop_context,
                                              my_data_context,
                                              put_index_data, mydata);
}

netsnmp_variable_list *
nasBackupTable_get_next_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    struct nasBackupTable_entry *entry =
        (struct nasBackupTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER,
                                   entry->nasBackupIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasBackupTable table */
int
nasBackupTable_handler(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasBackupTable_entry *table_entry;
    struct stat st;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasBackupTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || stat(table_entry->nasBackupFile, &st) != 0) {
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHINSTANCE);
                continue;
	    }

	    if (table_entry->nasBackupMtime != st.st_mtime) {
		nasBackupTable_updateEntry(table_entry);
		table_entry->nasBackupMtime = st.st_mtime;
	    }

	    if (table_entry->nasBackupStatus == NASBACKUPSTATUS_NONE) {
		netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
            case COLUMN_NASBACKUPNAME:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->nasBackupName,
                                         table_entry->nasBackupName_len);
                break;
#endif
            case COLUMN_NASBACKUPSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupStatus);
                break;
#if defined(BUFFALO_CONF_BACKUP_DETAIL_INFO)
            case COLUMN_NASBACKUPTRIGGER:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupTrigger);
                break;
            case COLUMN_NASBACKUPRUNTIME:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasBackupRunTime,
                                         table_entry->
                                         nasBackupRunTime_len);
                break;
            case COLUMN_NASBACKUPRUNDOW:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupRunDOW);
                break;
            case COLUMN_NASBACKUPRUNWEEK:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasBackupRunWeek);
                break;
            case COLUMN_NASBACKUPFOLDER:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasBackupFolder,
                                         table_entry->nasBackupFolder_len);
                break;
#endif
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the nasDiskTable table by defining its contents and how it's structured */
struct nasDiskTable_entry *
nasDiskTable_createEntry(long nasDiskIndex, char* nasDiskDisk);

void
initialize_table_nasDiskTable(void)
{
    const oid       nasDiskTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 2 };
    const size_t    nasDiskTable_oid_len = OID_LENGTH(nasDiskTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasDiskTable\n"));

    reg =
        netsnmp_create_handler_registration("nasDiskTable",
                                            nasDiskTable_handler,
                                            nasDiskTable_oid,
                                            nasDiskTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasDiskIndex */
                                     0);
    table_info->min_column = COLUMN_NASDISKSTATUS;
    table_info->max_column = COLUMN_NASSMART_OFFLINEUNCORRECTABLE_RAW;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasDiskTable_get_first_data_point;
    iinfo->get_next_data_point = nasDiskTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */

    for (i = nas_feature.max_disk_num; i > 0; i--)
	    nasDiskTable_createEntry(i, LINE_NASDISKDISK);
}

typedef struct nasDiskSMART_Attributes {
	int id;
	long value;
	long worst;
	long thresh;
	long long int raw;
	char str_raw[256];
	char attr_name[32];
	struct nasDiskSMART_Attributes * next;
} nasDiskSMART_Attributes_t;

    /*
     * Typical data structure for a row entry 
     */
struct nasDiskTable_entry {
    /*
     * Index values 
     */
    long            nasDiskIndex;

    char            nasDiskName[64];
    char            nasDiskDev[32];
    time_t          nasLastUpdate;

    /*
     * Column values 
     */
    long            nasDiskStatus;
    long            nasDiskCapacity;
    long            nasDiskUsed;

    /*
     * Smart info
     */
    long nasDiskSMARTStatus;
    nasDiskSMART_Attributes_t *nasDiskSMARTAttr;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasDiskTable_entry *next;
};

struct nasDiskTable_entry *nasDiskTable_head;

nasDiskSMART_Attributes_t * addSmartAttributeList(
	char *attr_name,
	nasDiskSMART_Attributes_t *head
)
{
	nasDiskSMART_Attributes_t *p = NULL;
	
	if ((p = (nasDiskSMART_Attributes_t *) malloc(sizeof(nasDiskSMART_Attributes_t))) == NULL) {
		printf("malloc error\n");
		exit(EXIT_FAILURE);
	}
	
	strncpy(p->attr_name, attr_name, sizeof(p->attr_name));
        p->value = -1;
        p->worst = -1;
        p->thresh = -1;
        p->raw = -1;
        strcpy(p->str_raw, "-1");

	p->next = head;
	head = p;

	return head;
}

void freeSmartAttributes(nasDiskSMART_Attributes_t *p)
{
	nasDiskSMART_Attributes_t *p2;

	while (p != NULL) {
		p2 = p->next;
		free(p);
		p = p2;
	}
}

nasDiskSMART_Attributes_t * getSmartAttributeFromName(
	char *attr_name,
	nasDiskSMART_Attributes_t *p)
{
	nasDiskSMART_Attributes_t *p2 = NULL;
	while (p != NULL) {
		if (strcmp(p->attr_name, attr_name) == 0){
			p2 = p;
			break;
		}
		p = p->next;
	}
	return p2;
}

nasDiskSMART_Attributes_t * addSmartAttributes(void)
{
	nasDiskSMART_Attributes_t *p = NULL;
	p = addSmartAttributeList(SMART_REALLOCATEDSECTORCT, p);
	p = addSmartAttributeList(SMART_CURRENTPENDINGSECTOR, p);
	p = addSmartAttributeList(SMART_OFFLINEUNCORRECTABLE, p);
	return p;
}

void initSmartAttributes(nasDiskSMART_Attributes_t *p)
{
	while (p != NULL) {
		p->value = -1;
		p->worst = -1;
		p->thresh = -1;
		p->raw = -1;
		strcpy(p->str_raw, "-1");
                p = p->next;
        }
}

char * getSmartSelfAssessment(char * buff)
{
	char * ret = NULL;
	if ( (buff = strstr(buff, SMART_SELFASSESSMENT)) ){
		//snmp_log(LOG_DEBUG, "found self assessment\n");
		ret = buff + strlen(SMART_SELFASSESSMENT);
		//snmp_log(LOG_DEBUG, "ret = %s", ret);
	}
	return ret;
}

int setSmartAttributesFromBuff(nasDiskSMART_Attributes_t *p,
                       char * buff)
{
	int ret = 0;
	char id[4];
	char name[32];
	char flag[8];
	char type[9];
	char updated[8];
	char when_failed[16];
	char *endptr;
	long long int val;
	while (p != NULL) {
		if ( strstr(buff, p->attr_name) ){
			sscanf(buff, "%3s%s%s%ld%ld%ld%s%s%s%s\n", id, name, flag, 
                                     &(p->value),
                                     &(p->worst),
                                     &(p->thresh),
                                     type, updated, when_failed,
                                     p->str_raw);
			strtok(p->str_raw, "\n");
			
			//snmp_log(LOG_DEBUG, "found %s\n", p->attr_name);
			//snmp_log(LOG_DEBUG, "value %ld\n", p->value);
			//snmp_log(LOG_DEBUG, "worst %ld\n", p->worst);
			//snmp_log(LOG_DEBUG, "thresh %ld\n", p->thresh);
			//snmp_log(LOG_DEBUG, "raw %s\n", p->str_raw);

			errno = 0;
			val = strtoll(p->str_raw, &endptr, 10);
			if ((errno != 0) || (*endptr != '\0')) {
				//snmp_log(LOG_DEBUG, "No digits were found, errno=%d endptr = %s\n", errno, endptr);
				p->raw = -1;
			} else {
				p->raw = val;
			}
			//snmp_log(LOG_DEBUG, "raw %lld\n", p->raw);
			ret = 1;
			break;
		}
		p = p->next;
	}
	return ret;
}

int isSmartStatusCaution(nasDiskSMART_Attributes_t *p)
{
	int ret = 0;
	while (p != NULL) {
		if (p->raw > 0){
			ret = 1;
			break;
		}
		p = p->next;
	}
	return ret;
}

int isSmartStatusNormal(nasDiskSMART_Attributes_t *p)
{
        int ret = 1;
        while (p != NULL) {
                if (p->raw != 0){
                        ret = 0;
                        break;
                }
		p = p->next;
        }
        return ret;
}

void setSmartStatus(struct nasDiskTable_entry *entry, 
                    char *selfAssessment)
{
	nasDiskSMART_Attributes_t *p = entry->nasDiskSMARTAttr;
	if (strcmp("FAILED!", selfAssessment) == 0){
		entry->nasDiskSMARTStatus = NASDISKSMARTSTATUS_FAIL;
	} else if (isSmartStatusCaution(p) == 1 ){
		entry->nasDiskSMARTStatus = NASDISKSMARTSTATUS_CAUTION;
	} else if (isSmartStatusNormal(p) == 1){
		entry->nasDiskSMARTStatus = NASDISKSMARTSTATUS_NORMAL;
	}
	//snmp_log(LOG_DEBUG, "nasDiskSMARTStatus = %ld\n", entry->nasDiskSMARTStatus);
}

void
nasDiskTable_updateEntry(struct nasDiskTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;
    unsigned long long capacity;
    time_t tm = time(NULL);
    char *devicename = entry->nasDiskName, *mntdirbase;

    if (tm - entry->nasLastUpdate <= 3) {
	return;
    }
    entry->nasLastUpdate = tm;

    if ((fp = fopen(FILE_NASDISKINFO, "r")) == NULL) {
       	return;
    }

    entry->nasDiskStatus = -1;
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	if ((buffp = getValue(entry->nasDiskName, buff)) != NULL) {
	    if (strcmp("normal", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_NORMAL;
	    else if (strcmp("array1", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY1;
	    else if (strcmp("array2", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY2;
	    else if (strcmp("standby", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_STANDBY;
	    else if (strcmp("degrade", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_DEGRADE;
	    else if (strcmp("remove", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_REMOVE;
	    else if (strcmp("standby_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_STANDBYREMOVED;
	    else if (strcmp("degrade_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_DEGRADEREMOVED;
	    else if (strcmp("remove_removed", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_REMOVEREMOVED;
	    else if (strcmp("array3", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY3;
	    else if (strcmp("array4", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_ARRAY4;
	    else if (strcmp("mc", buffp) == 0)
		entry->nasDiskStatus = NASDISKSTATUS_MEDIACARTRIDGE;
	    else if (strncmp("array", buffp, 5) == 0) { /* 5 = strlen("array") */
		int i;
		char arrstr[16];
		entry->nasDiskStatus = 0;
		for (i = 5; i <= 64; i++) {  /* array5(13) - array64(72) */
		    snprintf(arrstr, sizeof(arrstr), "array%d", i);
		    if (strcmp(arrstr, buffp) == 0) {
			entry->nasDiskStatus = NASDISK_ARRAYNUM2STATUS(i);
			break;
		    }
		}
	    }
	    else
		entry->nasDiskStatus = 0;
	} else if ((buffp = getValue(entry->nasDiskDev, buff)) != NULL) {
	    if (buffp[0] != '\0') {
		devicename = strdup(buffp);
	    }
	}
    }
    fclose(fp);

    if (entry->nasDiskStatus == NASDISKSTATUS_NORMAL ||
	entry->nasDiskStatus == NASDISKSTATUS_MEDIACARTRIDGE) {
        snprintf(buff, sizeof(buff),
	         "blockdev --getsize64 /dev/%s\n",
		 devicename);
	if ((fp = popen(buff, "r")) == NULL)
	    entry->nasDiskCapacity = -1;
	else {
	    fgets(buff, sizeof(buff), fp);
	    if (!WIFEXITED(pclose(fp)))
		entry->nasDiskCapacity = -1;
	    else {
	        capacity = strtoull(buff, &buffp, 10);
		entry->nasDiskCapacity = (long)(capacity / 1000000000);
	    }
	}

	switch (entry->nasDiskStatus) {
	case NASDISKSTATUS_MEDIACARTRIDGE:
	    mntdirbase = "mediacartridge";
	    break;
	case NASDISKSTATUS_NORMAL:
	default:
	    mntdirbase = "disk";
	    break;
	}
	snprintf(buff, sizeof(buff),
		 "df | grep '/mnt/%s%ld' | awk '{print $5}'\n",
		 mntdirbase, entry->nasDiskIndex);
	if ((fp = popen(buff, "r")) == NULL) {
		entry->nasDiskUsed = -1;
	} else {
		if (fgets(buff, sizeof(buff), fp) == NULL | !WIFEXITED(pclose(fp))) {
		    entry->nasDiskCapacity = -1;
		    entry->nasDiskUsed = -1;
		} else
		    entry->nasDiskUsed = strtol(buff, &buffp, 10);
	}
    } else {
	entry->nasDiskCapacity = -1;
	entry->nasDiskUsed = -1;
    }

    /* Smart info*/
    entry->nasDiskSMARTStatus = -1;
    initSmartAttributes(entry->nasDiskSMARTAttr);
    //snmp_log(LOG_DEBUG, "Start Smart info\n");
    snprintf(buff, sizeof(buff),"smartctl -H -A /dev/%s\n", entry->nasDiskName);
    //snmp_log(LOG_DEBUG, "command = %s\n", buff);
    if ((fp = popen(buff, "r"))) {
        char selfAssessment[8];
        char *result;
        while(fgets(buff, sizeof(buff), fp)) {
            //snmp_log(LOG_DEBUG, "%s", buff);
            if ( (result = getSmartSelfAssessment(buff)) ){
                strncpy(selfAssessment, result, sizeof(selfAssessment));
                strtok(selfAssessment, "\n");
                //snmp_log(LOG_DEBUG, "selfAssessment = %s\n", selfAssessment);
            } else {
                setSmartAttributesFromBuff(entry->nasDiskSMARTAttr, buff);
            }
        }
        setSmartStatus(entry, selfAssessment);
        pclose(fp);
    }

    if (devicename != entry->nasDiskName) {
	free(devicename);
    }
}
/*
 * create a new row in the (unsorted) table 
 */
struct nasDiskTable_entry *
nasDiskTable_createEntry(long nasDiskIndex, char* nasDiskDisk)
{
    struct nasDiskTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasDiskTable_entry);
    if (!entry)
        return NULL;

    entry->nasDiskIndex = nasDiskIndex;
    snprintf(entry->nasDiskName, sizeof(entry->nasDiskName),
	     "%s%d",
	     nasDiskDisk, nasDiskIndex);
    snprintf(entry->nasDiskDev, sizeof(entry->nasDiskDev),
	     "%s_dev",
	     entry->nasDiskName);
    entry->nasLastUpdate = 0;
    entry->nasDiskSMARTStatus = NASDISKSMARTSTATUS_UNKNOWN;
    entry->nasDiskSMARTAttr = addSmartAttributes();
    entry->next = nasDiskTable_head;
    nasDiskTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasDiskTable_removeEntry(struct nasDiskTable_entry *entry)
{
    struct nasDiskTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasDiskTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasDiskTable_head = ptr->next;
    else
        prev->next = ptr->next;

    freeSmartAttributes(entry->nasDiskSMARTAttr);
    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasDiskTable_get_first_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasDiskTable_head;
    return nasDiskTable_get_next_data_point(my_loop_context,
                                            my_data_context,
                                            put_index_data, mydata);
}

netsnmp_variable_list *
nasDiskTable_get_next_data_point(void **my_loop_context,
                                 void **my_data_context,
                                 netsnmp_variable_list * put_index_data,
                                 netsnmp_iterator_info *mydata)
{
    struct nasDiskTable_entry *entry =
        (struct nasDiskTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasDiskIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasDiskTable table */
int
nasDiskTable_handler(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasDiskTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasDiskTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry) {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

	    nasDiskTable_updateEntry(table_entry);

            nasDiskSMART_Attributes_t *rsc = getSmartAttributeFromName(
                                                SMART_REALLOCATEDSECTORCT,
                                                table_entry->nasDiskSMARTAttr);
            nasDiskSMART_Attributes_t *cps = getSmartAttributeFromName(
                                                SMART_CURRENTPENDINGSECTOR,
                                                table_entry->nasDiskSMARTAttr);
            nasDiskSMART_Attributes_t *ou = getSmartAttributeFromName(
                                                SMART_OFFLINEUNCORRECTABLE,
                                                table_entry->nasDiskSMARTAttr);
            switch (table_info->colnum) {
            case COLUMN_NASDISKSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskStatus);
                break;
            case COLUMN_NASDISKCAPACITY:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskCapacity);
                break;
            case COLUMN_NASDISKUSED:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskUsed);
                break;
            case COLUMN_NASSMART_STATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasDiskSMARTStatus);
                break;
            case COLUMN_NASSMART_REALLOCATEDSECTORCT_VALUE:
                if (rsc){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               rsc->value);
                }
                break;
            case COLUMN_NASSMART_REALLOCATEDSECTORCT_WORST:
                if (rsc){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               rsc->worst);
                }
                break;
            case COLUMN_NASSMART_REALLOCATEDSECTORCT_THRESH:
                if (rsc){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           rsc->thresh);
                }
                break;
            case COLUMN_NASSMART_REALLOCATEDSECTORCT_RAW:
                if (rsc){
                    snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                             (u_char *) rsc->str_raw,
                                             strlen(rsc->str_raw));
                }
                break;
            case COLUMN_NASSMART_CURRENTPENDINGSECTOR_VALUE:
                if (cps){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               cps->value);
                }
                break;
            case COLUMN_NASSMART_CURRENTPENDINGSECTOR_WORST:
                if (cps){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               cps->worst);
                }
                break;
            case COLUMN_NASSMART_CURRENTPENDINGSECTOR_THRESH:
                if (cps){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               cps->thresh);
                }
                break;
            case COLUMN_NASSMART_CURRENTPENDINGSECTOR_RAW:
                if (cps){
                    snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                             (u_char *) cps->str_raw,
                                             strlen(cps->str_raw));
                }
                break;
            case COLUMN_NASSMART_OFFLINEUNCORRECTABLE_VALUE:
                if (ou){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               ou->value);
                }
                break;
            case COLUMN_NASSMART_OFFLINEUNCORRECTABLE_WORST:
                if (ou){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           ou->worst);
                }
                break;
            case COLUMN_NASSMART_OFFLINEUNCORRECTABLE_THRESH:
                if (ou){
                    snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                               ou->thresh);
                }
                break;
            case COLUMN_NASSMART_OFFLINEUNCORRECTABLE_RAW:
                if (ou){
                    snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                             (u_char *) ou->str_raw,
                                             strlen(ou->str_raw));
                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the nasArrayTable table by defining its contents and how it's structured */
struct nasArrayTable_entry *
nasArrayTable_createEntry(long nasArrayIndex, char* nasArrayArray);

void
initialize_table_nasArrayTable(void)
{
    const oid       nasArrayTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 3 };
    const size_t    nasArrayTable_oid_len = OID_LENGTH(nasArrayTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasArrayTable\n"));

    reg =
        netsnmp_create_handler_registration("nasArrayTable",
                                            nasArrayTable_handler,
                                            nasArrayTable_oid,
                                            nasArrayTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasArrayIndex */
                                     0);
    table_info->min_column = COLUMN_NASARRAYSTATUS;
    table_info->max_column = COLUMN_NASARRAYUSED;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasArrayTable_get_first_data_point;
    iinfo->get_next_data_point = nasArrayTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = nas_feature.max_array_num; i > 0; i--)
	    nasArrayTable_createEntry(i, LINE_NASARRAYARRAY);
}

    /*
     * Typical data structure for a row entry 
     */
struct nasArrayTable_entry {
    /*
     * Index values 
     */
    long            nasArrayIndex;

    char            nasArrayName[64];
    char            nasArrayDev[32];
    time_t          nasLastUpdate;

    /*
     * Column values 
     */
    long            nasArrayStatus;
    long            nasArrayCapacity;
    long            nasArrayUsed;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasArrayTable_entry *next;
};

struct nasArrayTable_entry *nasArrayTable_head;

void
nasArrayTable_updateEntry(struct nasArrayTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp;
    unsigned long long capacity;
    time_t tm = time(NULL);
    char *devicename = NULL;

    if (tm - entry->nasLastUpdate <= 1) {
	return;
    }
    entry->nasLastUpdate = tm;

    if ((fp = fopen(FILE_NASARRAYINFO, "r")) == NULL) {
       	return;
    }

    entry->nasArrayStatus = -1;
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	if ((buffp = getValue(entry->nasArrayName, buff)) != NULL) {
	    if (strcmp("off", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_OFF;
	    else if (strcmp("raid0", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID0;
	    else if (strcmp("raid1", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID1;
	    else if (strcmp("raid5", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID5;
	    else if (strcmp("raid6", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID6;
	    else if (strcmp("raid10", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID10;
	    else if (strcmp("raid50", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID50;
	    else if (strcmp("raid51", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID51;
	    else if (strcmp("raid60", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID60;
	    else if (strcmp("raid61", buffp) == 0)
		entry->nasArrayStatus = NASARRAYSTATUS_RAID61;
	    else
		entry->nasArrayStatus = 0;
	} else if ((buffp = getValue(entry->nasArrayDev, buff))) {
	    devicename = strdup(buffp);
	}
    }
    fclose(fp);

    if (entry->nasArrayStatus != NASARRAYSTATUS_OFF && entry->nasArrayStatus != 0 && entry->nasArrayStatus != -1) {
	if (devicename == NULL) {
	    snprintf(buff, sizeof(buff),
		     "blockdev --getsize64 /dev/md%d",
		     entry->nasArrayStatus == NASARRAYSTATUS_RAID10 ? 4 :
		     entry->nasArrayIndex + 1);
	} else if (devicename[0] == '\0') {
	    snprintf(buff, sizeof(buff),
		     "blockdev --getsize64 /dev/md%d0",
		     entry->nasArrayIndex);
	} else {
	    snprintf(buff, sizeof(buff),
		     "blockdev --getsize64 /dev/%s",
		     devicename);
	}

	if ((fp = popen(buff, "r")) == NULL)
	    entry->nasArrayCapacity = -1;
	else {
	    fgets(buff, sizeof(buff), fp);
	    if (!WIFEXITED(pclose(fp)))
		entry->nasArrayCapacity = -1;
	    else {
	        capacity = strtoull(buff, &buffp, 10);
		entry->nasArrayCapacity = (long)(capacity / 1000000000);
	    }
	}

	snprintf(buff, sizeof(buff),
		 "df | grep '/mnt/%s' | awk '{print $5}'",
		 entry->nasArrayName);
	if ((fp = popen(buff, "r")) == NULL) {
		entry->nasArrayUsed = -1;
	} else {
		if (fgets(buff, sizeof(buff), fp) == NULL | !WIFEXITED(pclose(fp))) {
		    entry->nasArrayUsed = -1;
		} else
		    entry->nasArrayUsed = strtol(buff, &buffp, 10);
	}
    } else {
	entry->nasArrayCapacity = -1;
	entry->nasArrayUsed = -1;
    }

    free(devicename);
}
/*
 * create a new row in the (unsorted) table 
 */
struct nasArrayTable_entry *
nasArrayTable_createEntry(long nasArrayIndex, char* nasArrayArray)
{
    struct nasArrayTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasArrayTable_entry);
    if (!entry)
        return NULL;

    entry->nasArrayIndex = nasArrayIndex;
    snprintf(entry->nasArrayName, sizeof(entry->nasArrayName),
	     "%s%d",
	     nasArrayArray, nasArrayIndex);
    snprintf(entry->nasArrayDev, sizeof(entry->nasArrayDev),
	     "%s_dev",
	     entry->nasArrayName);
    entry->nasLastUpdate = 0;
    entry->next = nasArrayTable_head;
    nasArrayTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasArrayTable_removeEntry(struct nasArrayTable_entry *entry)
{
    struct nasArrayTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasArrayTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasArrayTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasArrayTable_get_first_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasArrayTable_head;
    return nasArrayTable_get_next_data_point(my_loop_context,
                                             my_data_context,
                                             put_index_data, mydata);
}

netsnmp_variable_list *
nasArrayTable_get_next_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    struct nasArrayTable_entry *entry =
        (struct nasArrayTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasArrayIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasArrayTable table */
int
nasArrayTable_handler(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasArrayTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasArrayTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry) {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

	    nasArrayTable_updateEntry(table_entry);

            switch (table_info->colnum) {
            case COLUMN_NASARRAYSTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayStatus);
                break;
            case COLUMN_NASARRAYCAPACITY:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayCapacity);
                break;
            case COLUMN_NASARRAYUSED:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasArrayUsed);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

    /*
     * Typical data structure for a row entry 
     */
struct nasErrorTable_entry {
    /*
     * Index values 
     */
    long            nasErrorIndex;

    /*
     * Column values 
     */
    char            nasErrorMsg[128];
    size_t          nasErrorMsg_len;
    char            nasErrorDate[128];
    size_t          nasErrorDate_len;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasErrorTable_entry *next;
};

struct nasErrorTable_entry *nasErrorTable_head;

/** Initialize the nasErrorTable table by defining its contents and how it's structured */
struct nasErrorTable_entry* nasErrorTable_createEntry(long nasErrorIndex);
void nasErrorTable_updateTable(unsigned int reg, void *clientarg);
int send_nasErrorOccur_trap(struct nasErrorTable_entry*);

void
initialize_table_nasErrorTable(void)
{
    const oid       nasErrorTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4 };
    const size_t    nasErrorTable_oid_len = OID_LENGTH(nasErrorTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init", "initializing table nasErrorTable\n"));

    reg =
        netsnmp_create_handler_registration("nasErrorTable",
                                            nasErrorTable_handler,
                                            nasErrorTable_oid,
                                            nasErrorTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasErrorIndex */
                                     0);
    table_info->min_column = COLUMN_NASERRORMSG;
    table_info->max_column = COLUMN_NASERRORDATE;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasErrorTable_get_first_data_point;
    iinfo->get_next_data_point = nasErrorTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASERRORSTATUS; i > 0; i--)
	    nasErrorTable_createEntry(i);

    nasErrorTable_updateTable(0, (void*)nasErrorTable_head);
    snmp_alarm_register(NASERROR_INTERVAL, SA_REPEAT,
			nasErrorTable_updateTable, nasErrorTable_head);
}

void
nasErrorTable_updateTable(unsigned int reg, void *clientarg)
{
    struct nasErrorTable_entry *head, *entry;
    char buff[NUM_NASERRORSTATUS][256], *buffp, *buffn;
    FILE *fp;
    int i, j;

    head = (struct nasErrorTable_entry*)clientarg;
    entry = head;
    
    snprintf(buff[0], sizeof(buff[0]),
	     "cat /tmp/error_status | tail -n %d\n",
	     NUM_NASERRORSTATUS);
    if ((fp = popen(buff[0], "r")) == NULL) {
	return;
    }
    for (i = 0; i < NUM_NASERRORSTATUS; i++) {
	if (fgets(buff[i], sizeof(buff[i]), fp) == NULL) {
	    for (j = i; j < NUM_NASERRORSTATUS; j++) {
		buff[j][0] = '\0';
	    }
	    break;
	}
    }
    if (!WIFEXITED(pclose(fp))) {
	return;
    }

    for (i = 0; i < NUM_NASERRORSTATUS; i++) {
	// delete space from buff's last
	buffp = &buff[i][strlen(buff[i])];
	while (buffp != buff[i] && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	// delete space from buff's first
	buffp = buff[i];
	while (isspace((int)*buffp)) {
	    buffp++;
	}

	buffn = buffp;
	while (!isspace((int)*buffn) && *buffn != '\0') {
	    buffn++;
	}
	if (*buffn != '\0') {
	    *(buffn++) = '\0';
	    while(isspace((int)*buffn)) {
		buffn++;
	    }
	}

	if (*buffp == '\0') {
	    entry->nasErrorMsg[0] = '\0';
	    entry->nasErrorMsg_len = 0;
	    entry->nasErrorDate[0] = '\0';
	    entry->nasErrorDate_len = 0;
	    entry = entry->next;
	    continue;
	}

	for (j = 0; errormon != NULL && j < errormon_num; j++) {
	    long pos = strlen(errormon[j]) - strlen(buffp);

	    if (pos < 0 || strcmp(buffp, &errormon[j][pos]) != 0) {
		continue;
	    }

	    snprintf(entry->nasErrorMsg, sizeof(entry->nasErrorMsg),
		     "%s", errormon[j]);
	    break;
	}
	if (errormon == NULL || j == errormon_num) {
		snprintf(entry->nasErrorMsg, sizeof(entry->nasErrorMsg),
			 "%s", buffp);
	}
	entry->nasErrorMsg_len = strlen(entry->nasErrorMsg);


	snprintf(entry->nasErrorDate, sizeof(entry->nasErrorDate),
		 "%s", buffn);
	entry->nasErrorDate_len = strlen(entry->nasErrorDate);


	if (entry->nasErrorMsg[0] != '\0') {
	    send_nasErrorOccur_trap(entry);
	}

	entry = entry->next;
    }
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasErrorTable_entry *
nasErrorTable_createEntry(long nasErrorIndex)
{
    struct nasErrorTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasErrorTable_entry);
    if (!entry)
        return NULL;

    entry->nasErrorIndex = nasErrorIndex;
    entry->next = nasErrorTable_head;
    nasErrorTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasErrorTable_removeEntry(struct nasErrorTable_entry *entry)
{
    struct nasErrorTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasErrorTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasErrorTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasErrorTable_get_first_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasErrorTable_head;

    return nasErrorTable_get_next_data_point(my_loop_context,
                                             my_data_context,
                                             put_index_data, mydata);
}

netsnmp_variable_list *
nasErrorTable_get_next_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    struct nasErrorTable_entry *entry =
        (struct nasErrorTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasErrorIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasErrorTable table */
int
nasErrorTable_handler(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasErrorTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasErrorTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || table_entry->nasErrorMsg[0] == '\0') {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
            case COLUMN_NASERRORMSG:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasErrorMsg,
                                         table_entry->nasErrorMsg_len);
                break;
            case COLUMN_NASERRORDATE:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasErrorDate,
                                         table_entry->nasErrorDate_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

    /*
     * Typical data structure for a row entry 
     */
struct nasInformationTable_entry {
    /*
     * Index values 
     */
    long            nasInformationIndex;

    /*
     * Column values 
     */
    char            nasInformationMsg[128];
    size_t          nasInformationMsg_len;
    char            nasInformationDate[128];
    size_t          nasInformationDate_len;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasInformationTable_entry *next;
};

struct nasInformationTable_entry *nasInformationTable_head;

/** Initialize the nasInformationTable table by defining its contents and how it's structured */
struct nasInformationTable_entry*
nasInformationTable_createEntry(long nasInformationIndex);
void nasInformationTable_updateTable(unsigned int reg, void *clientarg);
int send_nasInformationOccur_trap(struct nasInformationTable_entry*);

void
initialize_table_nasInformationTable(void)
{
    const oid       nasInformationTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5 };
    const size_t    nasInformationTable_oid_len =
        OID_LENGTH(nasInformationTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long i;

    DEBUGMSGTL(("teraStation:init",
                "initializing table nasInformationTable\n"));

    reg =
        netsnmp_create_handler_registration("nasInformationTable",
                                            nasInformationTable_handler,
                                            nasInformationTable_oid,
                                            nasInformationTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasInformationIndex */
                                     0);
    table_info->min_column = COLUMN_NASINFORMATIONMSG;
    table_info->max_column = COLUMN_NASINFORMATIONDATE;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasInformationTable_get_first_data_point;
    iinfo->get_next_data_point = nasInformationTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    for (i = NUM_NASINFORMATIONSTATUS; i > 0; i--)
	    nasInformationTable_createEntry(i);

    nasInformationTable_updateTable(0, (void*)nasInformationTable_head);
    snmp_alarm_register(NASINFORMATION_INTERVAL, SA_REPEAT,
			nasInformationTable_updateTable,
			nasInformationTable_head);
}

void
nasInformationTable_updateTable(unsigned int reg, void *clientarg)
{
    struct nasInformationTable_entry *head, *entry;
    char buff[NUM_NASINFORMATIONSTATUS][256], *buffp, *buffn;
    FILE *fp;
    int i, j;

    head = (struct nasInformationTable_entry*)clientarg;
    entry = head;
    
    snprintf(buff[0], sizeof(buff[0]),
	     "cat /tmp/info_status | tail -n %d\n",
	     NUM_NASINFORMATIONSTATUS);
    if ((fp = popen(buff[0], "r")) == NULL) {
	return;
    }
    for (i = 0; i < NUM_NASINFORMATIONSTATUS; i++) {
	if (fgets(buff[i], sizeof(buff[i]), fp) == NULL) {
	    for (j = i; j < NUM_NASINFORMATIONSTATUS; j++) {
		buff[j][0] = '\0';
	    }
	    break;
	}
    }
    if (!WIFEXITED(pclose(fp))) {
	return;
    }

    for (i = 0; i < NUM_NASINFORMATIONSTATUS; i++) {
	// delete space from buff's last
	buffp = &buff[i][strlen(buff[i])];
	while (buffp != buff[i] && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	// delete space from buff's first
	buffp = buff[i];
	while (isspace((int)*buffp)) {
	    buffp++;
	}

	buffn = buffp;
	while (!isspace((int)*buffn) && *buffn != '\0') {
	    buffn++;
	}
	if (*buffn != '\0') {
	    *(buffn++) = '\0';
	    while(isspace((int)*buffn)) {
		buffn++;
	    }
	}

	if (*buffp == '\0') {
	    entry->nasInformationMsg[0] = '\0';
	    entry->nasInformationMsg_len = 0;
	    entry->nasInformationDate[0] = '\0';
	    entry->nasInformationDate_len = 0;
	    entry = entry->next;
	    continue;
	}

	for (j = 0; errormon != NULL && j < errormon_num; j++) {
	    long pos = strlen(errormon[j]) - strlen(buffp);

	    if (pos < 0 || strcmp(buffp, &errormon[j][pos]) != 0) {
		continue;
	    }

	    snprintf(entry->nasInformationMsg,
		     sizeof(entry->nasInformationMsg),
		     "%s", errormon[j]);
	    break;
	}
	if (errormon == NULL || j == errormon_num) {
		snprintf(entry->nasInformationMsg,
			 sizeof(entry->nasInformationMsg),
			 "%s", buffp);
	}
	entry->nasInformationMsg_len = strlen(entry->nasInformationMsg);


	snprintf(entry->nasInformationDate, sizeof(entry->nasInformationDate),
		 "%s", buffn);
	entry->nasInformationDate_len = strlen(entry->nasInformationDate);


	if (entry->nasInformationMsg[0] != '\0') {
	    send_nasInformationOccur_trap(entry);
	}

	entry = entry->next;
    }
}

/*
 * create a new row in the (unsorted) table 
 */
struct nasInformationTable_entry *
nasInformationTable_createEntry(long nasInformationIndex)
{
    struct nasInformationTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasInformationTable_entry);
    if (!entry)
        return NULL;

    entry->nasInformationIndex = nasInformationIndex;
    entry->next = nasInformationTable_head;
    nasInformationTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasInformationTable_removeEntry(struct nasInformationTable_entry *entry)
{
    struct nasInformationTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasInformationTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasInformationTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasInformationTable_get_first_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasInformationTable_head;
    return nasInformationTable_get_next_data_point(my_loop_context,
                                                   my_data_context,
                                                   put_index_data, mydata);
}

netsnmp_variable_list *
nasInformationTable_get_next_data_point(void **my_loop_context,
                                        void **my_data_context,
                                        netsnmp_variable_list *
                                        put_index_data,
                                        netsnmp_iterator_info *mydata)
{
    struct nasInformationTable_entry *entry =
        (struct nasInformationTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER,
                                   entry->nasInformationIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasInformationTable table */
int
nasInformationTable_handler(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasInformationTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasInformationTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

	    if (!table_entry || table_entry->nasInformationMsg[0] == '\0') {
                netsnmp_set_request_error(reqinfo, request,
					  SNMP_NOSUCHINSTANCE);
		continue;
	    }

            switch (table_info->colnum) {
            case COLUMN_NASINFORMATIONMSG:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasInformationMsg,
                                         table_entry->
                                         nasInformationMsg_len);
                break;
            case COLUMN_NASINFORMATIONDATE:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         nasInformationDate,
                                         table_entry->
                                         nasInformationDate_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the nasVGTable table by defining its contents and how it's structured */
void nasVGLVTable_updateEntry(void);

void
initialize_table_nasVGTable(void)
{
    const oid       nasVGTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 6, 1 };
    const size_t    nasVGTable_oid_len = OID_LENGTH(nasVGTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    DEBUGMSGTL(("teraStation:init", "initializing table nasVGTable\n"));

    reg =
        netsnmp_create_handler_registration("nasVGTable",
                                            nasVGTable_handler,
                                            nasVGTable_oid,
                                            nasVGTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasVGIndex */
                                     0);
    table_info->min_column = COLUMN_NASVGPESIZE;
    table_info->max_column = COLUMN_NASVGPEUSED;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasVGTable_get_first_data_point;
    iinfo->get_next_data_point = nasVGTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct nasVGTable_entry {
    /*
     * Index values 
     */
    long            nasVGIndex;

    long            nasLVCount;
    long            nasPVCount;
    int             uptodate;
    /*
     * Column values 
     */
    long            nasVGPESize;
    long            nasVGPETotal;
    long            nasVGPEUsed;

    /* nasVGName work area purpose */
    char            nasVGName[64];
    size_t          nasVGName_len;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasVGTable_entry *next;
};

struct nasVGTable_entry *nasVGTable_head = NULL;

struct nasPVTable_entry *nasPVTable_createEntry(long  nasVGIndex, 
						long nasPVIndex, char *pvname);

/*
 * create a new row in the (unsorted) table 
 */
struct nasVGTable_entry *
nasVGTable_createEntry(long nasVGIndex, long pesize, long petotal, 
		       long peused, char *vgname, char *pvname)
{
    struct nasVGTable_entry *entry;

    for (entry = nasVGTable_head; entry != NULL; entry = entry->next) {
	if (entry->nasVGIndex == nasVGIndex) {
	    if (entry->uptodate == 1) {
		return entry;
	    }
	    entry->nasLVCount = 0;
	    entry->nasPVCount = 0;
	    entry->uptodate = 1;
	    break;
	}
    }
    if (entry == NULL) {
	entry = SNMP_MALLOC_TYPEDEF(struct nasVGTable_entry);
	if (!entry)
	    return NULL;
	entry->nasLVCount = 0;
	entry->nasPVCount = 0;
	entry->uptodate = 0;
    }

    entry->nasVGIndex = nasVGIndex;
    entry->nasVGPESize = pesize;
    entry->nasVGPETotal = petotal;
    entry->nasVGPEUsed = peused;
    strncpy(entry->nasVGName, vgname, sizeof(entry->nasVGName));
    entry->nasVGName_len = strlen(entry->nasVGName);

    if (entry->uptodate == 0) {
	entry->uptodate = 1;
	entry->next = nasVGTable_head;
	nasVGTable_head = entry;
    }

    nasPVTable_createEntry(entry->nasVGIndex, ++(entry->nasPVCount), pvname);

    return entry;
}

/*
 * remove a row from the table 
 */
void
nasVGTable_removeEntry(struct nasVGTable_entry *entry)
{
    struct nasVGTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasVGTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasVGTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasVGTable_get_first_data_point(void **my_loop_context,
                                void **my_data_context,
                                netsnmp_variable_list * put_index_data,
                                netsnmp_iterator_info *mydata)
{
    nasVGLVTable_updateEntry();
    *my_loop_context = nasVGTable_head;
    return nasVGTable_get_next_data_point(my_loop_context, my_data_context,
                                          put_index_data, mydata);
}

netsnmp_variable_list *
nasVGTable_get_next_data_point(void **my_loop_context,
                               void **my_data_context,
                               netsnmp_variable_list * put_index_data,
                               netsnmp_iterator_info *mydata)
{
    struct nasVGTable_entry *entry =
        (struct nasVGTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasVGIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasVGTable table */
int
nasVGTable_handler(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasVGTable_entry *table_entry;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

    if (nas_feature.support_lvm == 0) {
	netsnmp_set_request_error(reqinfo, request,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasVGTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_NASVGPESIZE:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasVGPESize);
                break;
            case COLUMN_NASVGPETOTAL:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasVGPETotal);
                break;
            case COLUMN_NASVGPEUSED:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasVGPEUsed);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}


//# Determine the first/last column names

/** Initialize the nasLVTable table by defining its contents and how it's structured */
void
initialize_table_nasLVTable(void)
{
    const oid       nasLVTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 6, 1, 1, 5 };
    const size_t    nasLVTable_oid_len = OID_LENGTH(nasLVTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    DEBUGMSGTL(("nasLVTable:init", "initializing table nasLVTable\n"));

    reg =
        netsnmp_create_handler_registration("nasLVTable",
                                            nasLVTable_handler,
                                            nasLVTable_oid,
                                            nasLVTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: nasVGIndex */
                                     ASN_INTEGER,       /* index: nasLVIndex */
				     //                                     ASN_OCTET_STR,       /* index: nasLVIndex */
                                     0);
    table_info->min_column = COLUMN_NASLVNAME;
    table_info->max_column = COLUMN_NASLVUSED;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasLVTable_get_first_data_point;
    iinfo->get_next_data_point = nasLVTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    nasVGLVTable_updateEntry();
}

    /*
     * Typical data structure for a row entry 
     */
struct nasLVTable_entry {
    /*
     * Index values 
     */
    long            nasVGIndex;
    long            nasLVIndex;

    long            nasLVNum;
    int             uptodate;
    /*
     * Column values 
     */
    char            nasLVName[64];
    size_t          nasLVName_len;
    long            nasLVCapacity;
    long            nasLVUsed;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct nasLVTable_entry *next;
};

struct nasLVTable_entry *nasLVTable_head = NULL;
static int nasVGIndexTotalCount;

/*
 * create a new row in the (unsorted) table 
 */
struct nasLVTable_entry*
nasLVTable_createEntry(long nasVGIndex, long nasLVIndex, long lvnum, char* lvname, long lvsize, const char *vgname)
{
    struct nasLVTable_entry *entry;
    FILE *fp;
    char buff[256], *buffp;

    for (entry = nasLVTable_head; entry != NULL; entry = entry->next) {
	if (entry->nasVGIndex == nasVGIndex &&
	    entry->nasLVIndex == nasLVIndex) {
	    if (entry->uptodate == 1) {
		return entry;
	    }
	    entry->uptodate = 1;
	    break;
	}
    }

    if (entry == NULL) {
	entry = SNMP_MALLOC_TYPEDEF(struct nasLVTable_entry);
	if (!entry)
	    return NULL;
	entry->uptodate = 0;
    }

    entry->nasVGIndex = nasVGIndex;
    entry->nasLVIndex = nasLVIndex;
    entry->nasLVNum = lvnum;
    snprintf(entry->nasLVName, sizeof(entry->nasLVName), "%s", lvname);
    entry->nasLVName_len = strlen(entry->nasLVName);
    entry->nasLVCapacity = lvsize;
    snprintf(buff, sizeof(buff),
	     "df | grep '/mnt/lvm/%s/lvm%ld_%s' | awk '{print $(NF-1)}'",
	     vgname, lvnum, lvname);
    if ((fp = popen(buff, "r")) == NULL) {
	entry->nasLVUsed = -1;
    } else {
	if (fgets(buff, sizeof(buff), fp) == NULL | !WIFEXITED(pclose(fp))) {
	    entry->nasLVCapacity = -1;
	    entry->nasLVUsed = -1;
	} else {
	    entry->nasLVUsed = strtol(buff, &buffp, 10);
	}
    }

    if (entry->uptodate == 0) {
	entry->uptodate = 1;
	entry->next = nasLVTable_head;
	nasLVTable_head = entry;
    }
    return entry;
}

/*
 * remove a row from the table 
 */
void
nasLVTable_removeEntry(struct nasLVTable_entry *entry)
{
    struct nasLVTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = nasLVTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        nasLVTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
nasLVTable_get_first_data_point(void **my_loop_context,
                                void **my_data_context,
                                netsnmp_variable_list * put_index_data,
                                netsnmp_iterator_info *mydata)
{
    nasVGLVTable_updateEntry();
    *my_loop_context = nasLVTable_head;
    return nasLVTable_get_next_data_point(my_loop_context, my_data_context,
                                          put_index_data, mydata);
}

netsnmp_variable_list *
nasLVTable_get_next_data_point(void **my_loop_context,
                               void **my_data_context,
                               netsnmp_variable_list * put_index_data,
                               netsnmp_iterator_info *mydata)
{
    struct nasLVTable_entry *entry =
        (struct nasLVTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasVGIndex);
        idx = idx->next_variable;
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasLVIndex);
	//        snmp_set_var_value(idx, entry->nasLVName,
	//                           strlen(entry->nasLVName));
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasLVTable table */
int
nasLVTable_handler(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasLVTable_entry *table_entry;

    DEBUGMSGTL(("nasLVTable:handler", "Processing request (%d)\n",
                reqinfo->mode));

    if (nas_feature.support_lvm == 0) {
	netsnmp_set_request_error(reqinfo, request,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasLVTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_NASLVNAME:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->nasLVName,
                                         table_entry->nasLVName_len);
                break;
            case COLUMN_NASLVCAPACITY:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasLVCapacity);
                break;
            case COLUMN_NASLVUSED:
		if (!table_entry) {
		    netsnmp_set_request_error(reqinfo, request,
					      SNMP_NOSUCHINSTANCE);
		    continue;
		}
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasLVUsed);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the nasPVTable table by defining its contents and how it's structured */
void
initialize_table_nasPVTable(void)
{
    static oid nasPVTable_oid[] = {1,3,6,1,4,1,5227,27,1,6,1,1,6};
    size_t nasPVTable_oid_len   = OID_LENGTH(nasPVTable_oid);
    netsnmp_handler_registration    *reg;
    netsnmp_iterator_info           *iinfo;
    netsnmp_table_registration_info *table_info;

    reg = netsnmp_create_handler_registration(
              "nasPVTable",     nasPVTable_handler,
              nasPVTable_oid, nasPVTable_oid_len,
              HANDLER_CAN_RONLY
              );

    table_info = SNMP_MALLOC_TYPEDEF( netsnmp_table_registration_info );
    netsnmp_table_helper_add_indexes(table_info,
                           ASN_INTEGER,  /* index: nasVGIndex */
                           ASN_INTEGER,  /* index: nasPVIndex */
                           0);
    table_info->min_column = COLUMN_NASPVNAME;
    table_info->max_column = COLUMN_NASPVNAME;
    
    iinfo = SNMP_MALLOC_TYPEDEF( netsnmp_iterator_info );
    iinfo->get_first_data_point = nasPVTable_get_first_data_point;
    iinfo->get_next_data_point  = nasPVTable_get_next_data_point;
    iinfo->table_reginfo        = table_info;
    
    netsnmp_register_table_iterator( reg, iinfo );

    /* Initialise the contents of the table here */
}

    /* Typical data structure for a row entry */
struct nasPVTable_entry {
    /* Index values */
    long nasVGIndex;
    long nasPVIndex;
    int  uptodate;

    /* Column values */
    char nasPVName[64];
    size_t nasPVName_len;

    /* Illustrate using a simple linked list */
    int   valid;
    struct nasPVTable_entry *next;
};

struct nasPVTable_entry  *nasPVTable_head = NULL;

static int
nasDevName2TsName(FILE *fp, const char *line_disk, const char *line_array, 
		  const char *pvName, char *tsName, int tsNameSize)
{
    char buff[256], *buffp;
    char *tmp;
    char strbuff[64], devname[64];
    int i;

    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';

	for (i = 1; i <= nas_feature.max_disk_num; i++)  {
	    sprintf(strbuff, line_disk, i);
	    if ((buffp = getValue(strbuff, buff)) != NULL) {
		sprintf(devname, "/dev/%s", buffp);
		if (strcmp(pvName, devname) == 0) {
		    snprintf(tsName, tsNameSize, "%s%d", LINE_NASDISKDISK, i);
		    return 1;
		}
	    }
	}
	for (i = 1; i <= nas_feature.max_array_num; i++)  {
	    sprintf(strbuff, line_array, i);
	    if ((buffp = getValue(strbuff, buff)) != NULL) {
		sprintf(devname, "/dev/%s", buffp);
		if (strcmp(pvName, devname) == 0) {
		    snprintf(tsName, tsNameSize, "%s%d", LINE_NASARRAYARRAY, i);
		    return 1;
		}
	    }
	}
    }
    return 0;
}

static int
nasDeviceNameTranslate(const char *pvName, char *tsName, int tsNameSize)
{
    FILE *fp;
    int rc = 0;

    if ((fp = fopen(FILE_NASDISKINFO, "r")) != NULL) {
	rc = nasDevName2TsName(fp, LINE_NASDISKDEV, LINE_NASARRAYDEV, 
			       pvName, tsName, tsNameSize);
	fclose(fp);
    }
    if (rc == 0) {
	if ((fp = fopen(FILE_NASFEATURE, "r")) != NULL) {
	    rc = nasDevName2TsName(fp, LINE_DEVICEHDD, LINE_DEVICEMD, 
				   pvName, tsName, tsNameSize);
	    fclose(fp);
	}
    }
    return rc;
}

/* create a new row in the (unsorted) table */
struct nasPVTable_entry *
nasPVTable_createEntry(
                 long  nasVGIndex,
                 long  nasPVIndex,
		 char  *pvname
                ) {
    struct nasPVTable_entry *entry;
    char tsname[64];

    for (entry = nasPVTable_head; entry != NULL; entry = entry->next) {
	if (entry->nasVGIndex == nasVGIndex &&
	    entry->nasPVIndex == nasPVIndex) {
	    if (entry->uptodate == 1) {
		return entry;
	    }
	    entry->uptodate = 1;
	    break;
	}
    }

    if (entry == NULL) {
	entry = SNMP_MALLOC_TYPEDEF(struct nasPVTable_entry);
	if (!entry)
	    return NULL;
	entry->uptodate = 0;
    }

    entry->nasVGIndex = nasVGIndex;
    entry->nasPVIndex = nasPVIndex;

    if (nasDeviceNameTranslate(pvname, tsname, sizeof(tsname))) {
	strncpy(entry->nasPVName, tsname, sizeof(entry->nasPVName));
    } else { /* maybe no reach */
	strncpy(entry->nasPVName, pvname, sizeof(entry->nasPVName));
    }
    entry->nasPVName_len = strlen(entry->nasPVName);

    if (entry->uptodate == 0) {
	entry->uptodate = 1;
	entry->next = nasPVTable_head;
	nasPVTable_head = entry;
    }
    return entry;
}

/* remove a row from the table */
void
nasPVTable_removeEntry( struct nasPVTable_entry *entry ) {
    struct nasPVTable_entry *ptr, *prev;

    if (!entry)
        return;    /* Nothing to remove */

    for ( ptr  = nasPVTable_head, prev = NULL;
          ptr != NULL;
          prev = ptr, ptr = ptr->next ) {
        if ( ptr == entry )
            break;
    }
    if ( !ptr )
        return;    /* Can't find it */

    if ( prev == NULL )
        nasPVTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE( entry );   /* XXX - release any other internal resources */
}


/* Example iterator hook routines - using 'get_next' to do most of the work */
netsnmp_variable_list *
nasPVTable_get_first_data_point(void **my_loop_context,
                          void **my_data_context,
                          netsnmp_variable_list *put_index_data,
                          netsnmp_iterator_info *mydata)
{
    nasVGLVTable_updateEntry();
    *my_loop_context = nasPVTable_head;
    return nasPVTable_get_next_data_point(my_loop_context, my_data_context,
                                    put_index_data,  mydata );
}

netsnmp_variable_list *
nasPVTable_get_next_data_point(void **my_loop_context,
                          void **my_data_context,
                          netsnmp_variable_list *put_index_data,
                          netsnmp_iterator_info *mydata)
{
    struct nasPVTable_entry *entry = (struct nasPVTable_entry *)*my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if ( entry ) {
        snmp_set_var_typed_integer( idx, ASN_INTEGER, entry->nasVGIndex );
        idx = idx->next_variable;
        snmp_set_var_typed_integer( idx, ASN_INTEGER, entry->nasPVIndex );
        idx = idx->next_variable;
        *my_data_context = (void *)entry;
        *my_loop_context = (void *)entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasPVTable table */
int
nasPVTable_handler(
    netsnmp_mib_handler               *handler,
    netsnmp_handler_registration      *reginfo,
    netsnmp_agent_request_info        *reqinfo,
    netsnmp_request_info              *requests) {

    netsnmp_request_info       *request;
    netsnmp_table_request_info *table_info;
    struct nasPVTable_entry          *table_entry;

    if (nas_feature.support_lvm == 0) {
	netsnmp_set_request_error(reqinfo, request,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request=requests; request; request=request->next) {
            table_entry = (struct nasPVTable_entry *)
                              netsnmp_extract_iterator_context(request);
            table_info  =     netsnmp_extract_table_info(      request);
    
            switch (table_info->colnum) {
            case COLUMN_NASPVNAME:
                if ( !table_entry ) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value( request->requestvb, ASN_OCTET_STR,
                                 (u_char*)table_entry->nasPVName,
                                          table_entry->nasPVName_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

time_t nasVGLVTable_lastUpdate = 0;

void
nasVGLVTable_updateEntry(void)
{
    time_t tm = time(NULL);
    FILE *vgfp = NULL, *lvfp = NULL;
    char buff[256], *buffp, lvname[64], pvname[64], tsname[64], vgname[64];
    long vgnum, pesize, petotal, pefree, lvsize, lvnum;
    float pesize_f, lvsize_f;
    struct nasVGTable_entry *vgentry, *vgprev;
    struct nasLVTable_entry *lventry, *lvprev;
    struct nasPVTable_entry *pventry, *pvprev;

	/* If the number of maximum creatable LVM Volumes is modified,
	 * the time below may be also modified a little longer.
	 */
    if (tm - nasVGLVTable_lastUpdate <= 5) {
		nasVGLVTable_lastUpdate = tm;
		return;
    }

    if ((vgfp = popen("vgdisplay -C --separator ' ' --units g -o vg_name,pv_name,vg_extent_size,vg_extent_count,vg_free_count -O vg_name", "r")) == NULL) {
	return;
    }

    if ((lvfp = popen("lvdisplay -C --separator ' ' --units g -o vg_name,lv_name,lv_size -O vg_name,lv_name", "r")) == NULL) {
	pclose(vgfp);
	return;
    }

    /* VG */
    nasVGIndexTotalCount = 0;
    while (fgets(buff, sizeof(buff), vgfp) != NULL) {
	buffp = &buff[strlen(buff)-1];
	while (*buffp == '\n' || *buffp == '\r') {
	    buffp--;
	}
	*(++buffp) = '\0';
	if (sscanf(buff,
		   "  %s %s %fG %ld %ld",
		   vgname, pvname, &pesize_f, &petotal, &pefree) != 5) {
		//LVMのバージョンによってはgが小文字になる
		if (sscanf(buff,
		   	"  %s %s %fg %ld %ld",
			   vgname, pvname, &pesize_f, &petotal, &pefree) != 5) {
			continue;
		}
	}
	for (vgentry = nasVGTable_head; vgentry != NULL; vgentry = vgentry->next) {
	    if (strncmp(vgentry->nasVGName, vgname, 
			sizeof(vgentry->nasVGName)) == 0 && 
		vgentry->uptodate == 1) {
		/* already create VG entry */
		nasPVTable_createEntry(vgentry->nasVGIndex, 
				       ++(vgentry->nasPVCount), pvname);
		break;
	    }
	}
	if (vgentry != NULL) {
	    continue;
	}
	pesize = (long)pesize_f;
	nasVGTable_createEntry(++nasVGIndexTotalCount, pesize, petotal, 
			       petotal - pefree, vgname, pvname);
    }
    pclose(vgfp);

    /* LV */
    while (fgets(buff, sizeof(buff), lvfp) != NULL) {
	buffp = &buff[strlen(buff)-1];
	while (*buffp == '\n' || *buffp == '\r') {
	    buffp--;
	}
	*(++buffp) = '\0';
	if (sscanf(buff,
		   "  %s lvm%ld_%s %fG",
		   vgname, &lvnum, &lvname, &lvsize_f) != 4) {
	    continue;
	}
	for (vgentry = nasVGTable_head; vgentry != NULL; vgentry = vgentry->next) {
	    if (strncmp(vgentry->nasVGName, vgname, 
			sizeof(vgentry->nasVGName)) == 0 &&
		vgentry->uptodate == 1) {
		break;
	    }
	}
	if (vgentry == NULL) {
	    continue;
	}
	lvsize = (long)lvsize_f;
	nasLVTable_createEntry(vgentry->nasVGIndex, ++(vgentry->nasLVCount), 
			       lvnum, lvname, lvsize, vgname);
    }
    pclose(lvfp);

    pvprev = NULL;
    pventry = nasPVTable_head;
    while (pventry != NULL) {
	if (pventry->uptodate == 0) {
	    if (pvprev == NULL) {
		nasPVTable_head = pventry->next;
		SNMP_FREE(pventry);
		pventry = nasPVTable_head;
	    } else {
		pvprev->next = pventry->next;
		SNMP_FREE(pventry);
		pventry = pvprev->next;
	    }
	} else {
	    pventry->uptodate = 0;
	    pvprev = pventry;
	    pventry = pvprev->next;
	}
    }

    lvprev = NULL;
    lventry = nasLVTable_head;
    while (lventry != NULL) {
	if (lventry->uptodate == 0) {
	    if (lvprev == NULL) {
		nasLVTable_head = lventry->next;
		SNMP_FREE(lventry);
		lventry = nasLVTable_head;
	    } else {
		lvprev->next = lventry->next;
		SNMP_FREE(lventry);
		lventry = lvprev->next;
	    }
	} else {
	    lventry->uptodate = 0;
	    lvprev = lventry;
	    lventry = lvprev->next;
	}
    }
    vgprev = NULL;
    vgentry = nasVGTable_head;
    while (vgentry != NULL) {
	if (vgentry->uptodate == 0) {
	    if (vgprev == NULL) {
		nasVGTable_head = vgentry->next;
		SNMP_FREE(vgentry);
		vgentry = nasVGTable_head;
	    } else {
		vgprev->next = vgentry->next;
		SNMP_FREE(vgentry);
		vgentry = vgprev->next;
	    }
	} else {
	    vgentry->uptodate = 0;
	    vgprev = vgentry;
	    vgentry = vgprev->next;
	}
    }
    nasVGLVTable_lastUpdate = tm;
}

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf 17337 2009-01-01 14:28:29Z magfr $
 */

/** Initializes the nasFailoverParams module */
void
init_nasFailoverParams(void)
{
    const oid       nasFailoverRole_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 7, 1 };
    const oid       nasFailoverStatus_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 7, 2 };
    const oid       nasFailoverPartner_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 7, 3 };

    DEBUGMSGTL(("nasFailoverParams", "Initializing\n"));

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("nasFailoverRole", handle_nasFailoverRole,
                             nasFailoverRole_oid,
                             OID_LENGTH(nasFailoverRole_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("nasFailoverStatus", handle_nasFailoverStatus,
                             nasFailoverStatus_oid,
                             OID_LENGTH(nasFailoverStatus_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("nasFailoverPartner",
                             handle_nasFailoverPartner,
                             nasFailoverPartner_oid,
                             OID_LENGTH(nasFailoverPartner_oid),
                             HANDLER_CAN_RONLY));
}

int
handle_nasFailoverRole(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{
    if (nas_feature.support_fofb == 0) {
	netsnmp_set_request_error(reqinfo, requests,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */
    FILE *fp;
    char buff[256], *buffp, *tmp;
    int value = -1;

    if ((fp = fopen(FILE_NASFOFBSTATUS, "r")) != NULL) {
	while (fgets(buff, sizeof(buff), fp) != NULL) {
	    if ((buffp = strstr(buff, NASFOFB_SEPARATOR)) == NULL) {
		continue;
	    }
	    *buffp = '\0';
	    value = strtol(buff, &tmp, 10);
	    if (buff == tmp || *tmp != '\0') {
		value = -1;
		continue;
	    }
	    switch (value) {
	    case NASFOFBROLE_STANDALONE:
	    case NASFOFBROLE_MAIN:
	    case NASFOFBROLE_ALONEMAIN:
	    case NASFOFBROLE_BACKUP:
	    case NASFOFBROLE_ALONEBACKUP:
	    case NASFOFBROLE_MAINTENANCEMAIN:
	    case NASFOFBROLE_MAINTENANCEBACKUP:
	    case NASFOFBROLE_EMMODE:
		break;
	    default:
		value = -1;
		continue;
	    }
	    break;
	}
	fclose(fp);
    }

    switch (reqinfo->mode) {

    case MODE_GET:
	snmp_set_var_typed_integer(requests->requestvb, ASN_INTEGER, value);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasFailoverRole\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_nasFailoverStatus(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{
    if (nas_feature.support_fofb == 0) {
	netsnmp_set_request_error(reqinfo, requests,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */
    FILE *fp;
    char buff[256], *buffp, *tmp;
    int value = -1;

    if ((fp = fopen(FILE_NASFOFBSTATUS, "r")) != NULL) {
	while (fgets(buff, sizeof(buff), fp) != NULL) {
	    if ((buffp = strstr(buff, NASFOFB_SEPARATOR)) == NULL) {
		continue;
	    }
	    tmp = &buff[strlen(buff)-1];
	    while (*tmp == '\n' || *tmp == '\r') {
		tmp--;
	    }
	    *(++tmp) = '\0';
	    
	    buffp += strlen(NASFOFB_SEPARATOR);
	    value = strtol(buffp, &tmp, 10);
	    if (buffp == tmp || *tmp != '\0') {
		value = -1;
		continue;
	    }
	    switch (value) {
	    case NASFOFBSTATUS_IDLE:
	    case NASFOFBSTATUS_BUSY:
	    case NASFOFBSTATUS_STARTMAIN:
	    case NASFOFBSTATUS_STARTBACKUP:
	    case NASFOFBSTATUS_INITIALIZE:
	    case NASFOFBSTATUS_STOP:
		break;
	    default:
		value = -1;
		continue;
	    }
	    break;
	}
	fclose(fp);
    }

    switch (reqinfo->mode) {

    case MODE_GET:
	snmp_set_var_typed_integer(requests->requestvb, ASN_INTEGER, value);
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_nasFailoverStatus\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_nasFailoverPartner(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{
    if (nas_feature.support_fofb == 0) {
	netsnmp_set_request_error(reqinfo, requests,
				  SNMP_NOSUCHINSTANCE);
	return SNMP_ERR_NOERROR;
    }

    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */
    FILE *fp;
    char buff[256], *buffp;
    struct in_addr inp;
   
    inet_aton("0.0.0.0", &inp);
    if ((fp = fopen(FILE_NASFOFBINFO, "r")) != NULL) {
	while(fgets(buff, sizeof(buff), fp) != NULL) {
	    if ((buffp = strstr(buff, NASFOFB_SEPARATOR)) == NULL) {
		continue;
	    }
	    buffp += strlen(NASFOFB_SEPARATOR);
	    if (inet_aton(buffp, &inp) == 0) {
		continue;
	    }
	    break;
	}
	fclose(fp);
    }

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_IPADDRESS,
                                 (u_char *)&inp
                                 /* XXX: a pointer to the scalar's data */
                                 , sizeof(inp)
                                 /*
                                  * XXX: the length of the data in bytes 
                                  */ );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_nasFailoverPartner\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.iterate.conf 15999 2007-03-25 22:32:02Z dts12 $
 */

/** Initialize the nasRPSUTable table by defining its contents and how it's structured */
void nasRPSUTable_initEntry(void);
struct nasRPSUTable_entry *nasRPSUTable_createEntry(long  nasRPSUIndex);

void
initialize_table_nasRPSUTable(void)
{
    static oid nasRPSUTable_oid[] = {1,3,6,1,4,1,5227,27,1,8};
    size_t nasRPSUTable_oid_len   = OID_LENGTH(nasRPSUTable_oid);
    netsnmp_handler_registration    *reg;
    netsnmp_iterator_info           *iinfo;
    netsnmp_table_registration_info *table_info;

    reg = netsnmp_create_handler_registration(
              "nasRPSUTable",     nasRPSUTable_handler,
              nasRPSUTable_oid, nasRPSUTable_oid_len,
              HANDLER_CAN_RONLY
              );

    table_info = SNMP_MALLOC_TYPEDEF( netsnmp_table_registration_info );
    netsnmp_table_helper_add_indexes(table_info,
                           ASN_INTEGER,  /* index: nasRPSUIndex */
                           0);
    table_info->min_column = COLUMN_NASRPSUSTATUS;
    table_info->max_column = COLUMN_NASRPSUSTATUS;
    
    iinfo = SNMP_MALLOC_TYPEDEF( netsnmp_iterator_info );
    iinfo->get_first_data_point = nasRPSUTable_get_first_data_point;
    iinfo->get_next_data_point  = nasRPSUTable_get_next_data_point;
    iinfo->table_reginfo        = table_info;
    
    netsnmp_register_table_iterator( reg, iinfo );

    /* Initialise the contents of the table here */
    nasRPSUTable_initEntry();
}

    /* Typical data structure for a row entry */
struct nasRPSUTable_entry {
    /* Index values */
    long nasRPSUIndex;

    /* Column values */
    long nasRPSUStatus;

    /* Illustrate using a simple linked list */
    int   valid;
    struct nasRPSUTable_entry *next;
};

struct nasRPSUTable_entry  *nasRPSUTable_head;

void
nasRPSUTable_initEntry(void)
{
    long  index;
    FILE *fp;
    char buff[256], *buffp, strbuff[32];
    struct nasRPSUTable_entry *entry;

    if ((fp = popen("miconapl -a rpsu_get_status", "r")) == NULL) {
	return;
    }
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';
	for (index = 1; index <= NUM_NASRPSUINFO; index++) {
	    sprintf(strbuff, LINE_RPSUSTATUS, index);
	    if ((buffp = getValue(strbuff, buff)) != NULL) {
		entry = nasRPSUTable_createEntry(index);
		if (entry) {
		    if (strcmp(buffp, "fine") == 0) {
			entry->nasRPSUStatus = NASRPSUSTATUS_FINE;
		    } else if (strcmp(buffp, "broken") == 0) {
			entry->nasRPSUStatus = NASRPSUSTATUS_BROKEN;
		    } else {
			entry->nasRPSUStatus = NASRPSUSTATUS_UNKNOWN;
		    }
		    break;
		}
	    }
	}
    }
    pclose(fp);
}


void
nasRPSUTable_updateEntry(struct nasRPSUTable_entry *entry)
{
    FILE *fp;
    char buff[256], *buffp, strbuff[32];

    if (entry == NULL) {
	return;
    }
    if ((fp = popen("miconapl -a rpsu_get_status", "r")) == NULL) {
	return;
    }
    while (fgets(buff, sizeof(buff), fp) != NULL) {
	buffp = &buff[strlen(buff)];
	while (buffp != buff && isspace((int)*(buffp-1))) {
	    buffp--;
	}
	*buffp = '\0';
	sprintf(strbuff, LINE_RPSUSTATUS, entry->nasRPSUIndex);
	if ((buffp = getValue(strbuff, buff)) != NULL) {
	    if (strcmp(buffp, "fine") == 0) {
		entry->nasRPSUStatus = NASRPSUSTATUS_FINE;
	    } else if (strcmp(buffp, "broken") == 0) {
		entry->nasRPSUStatus = NASRPSUSTATUS_BROKEN;
	    } else {
		entry->nasRPSUStatus = NASRPSUSTATUS_UNKNOWN;
	    }
	    break;
	}
    }
    pclose(fp);
}


/* create a new row in the (unsorted) table */
struct nasRPSUTable_entry *
nasRPSUTable_createEntry(
                 long  nasRPSUIndex
                ) {
    struct nasRPSUTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasRPSUTable_entry);
    if (!entry)
        return NULL;

    entry->nasRPSUIndex = nasRPSUIndex;
    entry->next = nasRPSUTable_head;
    nasRPSUTable_head = entry;
    return entry;
}

/* remove a row from the table */
void
nasRPSUTable_removeEntry( struct nasRPSUTable_entry *entry ) {
    struct nasRPSUTable_entry *ptr, *prev;

    if (!entry)
        return;    /* Nothing to remove */

    for ( ptr  = nasRPSUTable_head, prev = NULL;
          ptr != NULL;
          prev = ptr, ptr = ptr->next ) {
        if ( ptr == entry )
            break;
    }
    if ( !ptr )
        return;    /* Can't find it */

    if ( prev == NULL )
        nasRPSUTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE( entry );   /* XXX - release any other internal resources */
}


/* Example iterator hook routines - using 'get_next' to do most of the work */
netsnmp_variable_list *
nasRPSUTable_get_first_data_point(void **my_loop_context,
                          void **my_data_context,
                          netsnmp_variable_list *put_index_data,
                          netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasRPSUTable_head;
    return nasRPSUTable_get_next_data_point(my_loop_context, my_data_context,
                                    put_index_data,  mydata );
}

netsnmp_variable_list *
nasRPSUTable_get_next_data_point(void **my_loop_context,
                          void **my_data_context,
                          netsnmp_variable_list *put_index_data,
                          netsnmp_iterator_info *mydata)
{
    struct nasRPSUTable_entry *entry = (struct nasRPSUTable_entry *)*my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if ( entry ) {
        snmp_set_var_typed_integer( idx, ASN_INTEGER, entry->nasRPSUIndex );
        idx = idx->next_variable;
        *my_data_context = (void *)entry;
        *my_loop_context = (void *)entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the nasRPSUTable table */
int
nasRPSUTable_handler(
    netsnmp_mib_handler               *handler,
    netsnmp_handler_registration      *reginfo,
    netsnmp_agent_request_info        *reqinfo,
    netsnmp_request_info              *requests) {

    netsnmp_request_info       *request;
    netsnmp_table_request_info *table_info;
    struct nasRPSUTable_entry          *table_entry;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request=requests; request; request=request->next) {
            table_entry = (struct nasRPSUTable_entry *)
                              netsnmp_extract_iterator_context(request);
            table_info  =     netsnmp_extract_table_info(      request);

	    nasRPSUTable_updateEntry(table_entry);
    
            switch (table_info->colnum) {
            case COLUMN_NASRPSUSTATUS:
                if ( !table_entry ) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer( request->requestvb, ASN_INTEGER,
                                            table_entry->nasRPSUStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.notify.conf 17455 2009-04-05 09:53:29Z magfr $
 */
static const oid snmptrap_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };

int
send_nasErrorOccur_trap(struct nasErrorTable_entry *entry)
{
    netsnmp_variable_list *var_list = NULL;
    const oid       nasErrorOccur_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 2, 1 };
    const oid       nasErrorMsg_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4, 1, 2, entry->nasErrorIndex
        };
    const oid       nasErrorDate_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 4, 1, 3, entry->nasErrorIndex
        };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, OID_LENGTH(snmptrap_oid),
                              ASN_OBJECT_ID,
                              nasErrorOccur_oid,
                              sizeof(nasErrorOccur_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              nasErrorMsg_oid, OID_LENGTH(nasErrorMsg_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasErrorMsg 
                               */
                              entry->nasErrorMsg, entry->nasErrorMsg_len);
    snmp_varlist_add_variable(&var_list,
                              nasErrorDate_oid,
                              OID_LENGTH(nasErrorDate_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasErrorDate 
                               */
                              entry->nasErrorDate, entry->nasErrorDate_len);

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_nasInformationOccur_trap(struct nasInformationTable_entry *entry)
{
    netsnmp_variable_list *var_list = NULL;
    const oid       nasInformationOccur_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 2, 2 };
    const oid       nasInformationMsg_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5, 1, 2, entry->nasInformationIndex
        };
    const oid       nasInformationDate_oid[] =
        { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 5, 1, 3, entry->nasInformationIndex
        };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, OID_LENGTH(snmptrap_oid),
                              ASN_OBJECT_ID,
                              nasInformationOccur_oid,
                              sizeof(nasInformationOccur_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              nasInformationMsg_oid,
                              OID_LENGTH(nasInformationMsg_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasInformationMsg 
                               */
                              entry->nasInformationMsg, entry->nasInformationMsg_len);
    snmp_varlist_add_variable(&var_list,
                              nasInformationDate_oid,
                              OID_LENGTH(nasInformationDate_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for nasInformationDate 
                               */
                              entry->nasInformationDate, entry->nasInformationDate_len);

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}


/* ----------------
 *  iSCSI Section
 * ---------------- */
/* Typical data structure for a row entry */
struct nasISCSITable_entry {
     /* Index values */
    long	nasISCSIIndex;

    /* Column values */
    char	nasISCSIName[40];
	size_t	nasISCSIName_len;
    long	nasISCSIStatus;

    time_t	nasLastUpdate;
    /* Illustrate using a simple linked list */
    int		valid;
    struct	nasISCSITable_entry *next;
};

/* Global pointer that points to the latest active "entry" object */
// ( Needs to be initialized to NULL for removeEntry function !? )
struct nasISCSITable_entry *nasISCSITable_head = NULL;

/* Global pointer that keeps the last-allocated "entry" object */
struct nasISCSITable_entry *nasISCSITable_saved_head = NULL;

struct nasISCSITable_entry *
nasISCSITable_createEntry(long nasISCSIIndex);


void
initialize_table_nasISCSITable(void)
{
    const oid	nasISCSITable_oid[] = { 1, 3, 6, 1, 4, 1, 5227, 27, 1, 9 };
    const size_t	nasISCSITable_oid_len = OID_LENGTH(nasISCSITable_oid);

    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    long f_num;
	struct stat st;
	char f_name[32];

    DEBUGMSGTL(("teraStation:init", "initializing table nasISCSITable\n"));

    reg =
        netsnmp_create_handler_registration("nasISCSITable",
                                            nasISCSITable_handler,
                                            nasISCSITable_oid,
                                            nasISCSITable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
	/* index : nasISCSIIndex */
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER, 0);

    table_info->min_column = COLUMN_NASISCSINAME;
    table_info->max_column = COLUMN_NASISCSISTATUS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = nasISCSITable_get_first_data_point;
    iinfo->get_next_data_point = nasISCSITable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

	/* Allocate objects which contents are initialized */
#ifdef ZERO_INDEXED_LUNS
    for (f_num = 0; f_num <= nas_feature.max_iscsi_num; f_num++){
#else
    for (f_num = 1; f_num <= nas_feature.max_iscsi_num; f_num++){
#endif
		nasISCSITable_createEntry(f_num);
	}
}


void
nasISCSITable_updateEntry(struct nasISCSITable_entry *entry)
{
    FILE *fp;
    char buff[1024], *pBuff = NULL, f_name[32], tgt_name[40], name_low[40], *pChar;
	struct stat st;
    time_t tm = time(NULL);
	int i, f_num, sp_count;

    if ( tm - (entry->nasLastUpdate) <= 1 ) {
		return;
    }
    entry->nasLastUpdate = tm;

	/* Write the values to the object */
	f_num = 0;
#ifdef ZERO_INDEXED_LUNS
	for (i = 0; i <= NUM_NASISCSIINFO_LIMIT; i++){
#else
	for (i = 1; i <= NUM_NASISCSIINFO_LIMIT; i++){
#endif
		snprintf(f_name, sizeof(f_name), FILE_NASISCSIINFO, i);
		if ( !stat(f_name, &st) ){
			f_num++;

#ifdef ZERO_INDEXED_LUNS
			if ( i == entry->nasISCSIIndex ){
#else
			if ( f_num == entry->nasISCSIIndex ){
#endif
				entry->nasISCSIStatus = NASISCSISTATUS_UNKNOWN;
				if ( (fp = fopen(f_name, "r")) == NULL ){
					return;	/* Can't open the file */
				}
				/* SET THE VOLUME NAME */
				
				while ( fgets(buff, sizeof(buff), fp) != NULL ){
					pBuff = &buff[strlen(buff)];
					while ( (pBuff != buff) && isspace((int)*(pBuff-1)) ){
						pBuff--;
					}
					*pBuff = '\0';
					if ( (pBuff = getValue(LINE_NASISCSITARGET, buff)) != NULL ){
						strncpy(entry->nasISCSIName, pBuff, sizeof(entry->nasISCSIName));
						entry->nasISCSIName_len = strlen(entry->nasISCSIName);
						break;
					}
				}
				fclose(fp);	/* For "FILE_NASISCSIINFO" */

				if (pBuff == NULL || (strlen(entry->nasISCSIName) == 0)) {
					return;
				}

				/* SET THE STATUS */
				if ( (fp = fopen(FILE_NASISCSISTATUS, "r")) == NULL ) {
					return;	/* Can't open the file */
				}
				while ( fgets(buff, sizeof(buff), fp) != NULL ){
					if ( !isdigit((int)(buff[0])) ){ /* As long as "break" doesn't occur */
						entry->nasISCSIStatus = NASISCSISTATUS_STANDINGBY;
					}
					else {
						pBuff = buff;
						sp_count = 0;
						while ( *pBuff != '\n' ){
							if ( isspace((int)(*pBuff)) ){
								sp_count++;
								if (sp_count >= NASISCSI_SP_NUM_IQN){
									break;
								}
							}
							pBuff++;
						}
						*pBuff = '\0';
						while ( (pBuff != buff) && (*pBuff != '.') ){
							pBuff--;
						}
						pBuff++;
						/* At this point
						 * |inst|...|IQN(xxx....xxx.volume_name|\0|TSIH|...
						 *                          ^pBuff
						 */
						strcpy(name_low, entry->nasISCSIName);
						for ( pChar = name_low; *pChar; pChar++ ){
							*pChar = tolower(*pChar);
						}
						if ( strncmp(name_low, pBuff, strlen(name_low)) == 0 ){
							pBuff = buff;
							sp_count = 0;
							while ( pBuff != '\0' ){
								if ( isspace((int)(*pBuff)) ){
									sp_count++;
									if (sp_count >= NASISCSI_SP_NUM_DIR){
										break;
									}
								}
								pBuff++;
							}
							pBuff++;
							/* At this point
							 * |inst| |node| |indx| |dir| |intr_name|...
							 *                       ^pBuff
							 */

							/* [Vol-Name] exist [Word "Inbound"] exist => Connected */
							if ( strncmp(LINE_NASISCSI_INBOUND, pBuff,
									strlen(LINE_NASISCSI_INBOUND)) == 0 ){
								entry->nasISCSIStatus = NASISCSISTATUS_CONNECTED;
								break;
							} else { /* [Vol-Name] exist [Word "Inbound"] not found => Unknown */
								entry->nasISCSIStatus = NASISCSISTATUS_UNKNOWN;
								break;
							}
						}
					}
				}
				fclose(fp);	/* For "FILE_NASISCSISTATUS" */
				return;	/* Write finishd ! */
			}
		}
	}
}


/* Create a new row in the (unsorted) table */
struct nasISCSITable_entry *
nasISCSITable_createEntry(long nasISCSIIndex)
{
    struct nasISCSITable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct nasISCSITable_entry);
    if ( !entry ) {
        return NULL;
	}

    entry->nasISCSIIndex = nasISCSIIndex;

	// Name and its length need to initialize again ???
	//strcpy(entry->nasISCSIName, "");
	//entry->nasISCSIName_len = strlen(entry->nasISCSIName);
    entry->nasLastUpdate = 0;

	/* [New-allocated object address] ==> head
	 * [Previous allocated object address] ==> "next"  */
    entry->next = nasISCSITable_head;
    nasISCSITable_head = entry;
    nasISCSITable_saved_head = nasISCSITable_head;
    return entry;
}

/* Remove a row from the table */
void
nasISCSITable_removeEntry(struct nasISCSITable_entry *entry)
{
    struct nasISCSITable_entry *ptr, *prev;

	/* Nothing to remove */
    if (!entry)
        return;

    for (ptr = nasISCSITable_head, prev = NULL;
         ptr != NULL;
		 prev = ptr, ptr = ptr->next)
	{
        if (ptr == entry)
            break;
    }

	/* Not existed among all the objects */
    if (!ptr)
        return;

	/* Moving over */
    if (prev == NULL) {
        nasISCSITable_head = ptr->next;
	} else {
        prev->next = ptr->next;
	}
	/* Release any other internal resources */
    SNMP_FREE(entry);
}


/* Example iterator hook routines - using 'get_next' to do most of the work */
netsnmp_variable_list *
nasISCSITable_get_first_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    *my_loop_context = nasISCSITable_head;
    return nasISCSITable_get_next_data_point(my_loop_context,
                                            my_data_context,
                                            put_index_data, mydata);
}

netsnmp_variable_list *
nasISCSITable_get_next_data_point(void **my_loop_context,
                                 void **my_data_context,
                                 netsnmp_variable_list * put_index_data,
                                 netsnmp_iterator_info *mydata)
{
    struct nasISCSITable_entry *entry =
        (struct nasISCSITable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->nasISCSIIndex);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/* Handles requests for the nasISCSITable table */
int
nasISCSITable_handler(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct nasISCSITable_entry *table_entry, *spTemp;
	int i, f_sum, sa_exist;
	char f_name[32];
	struct stat st;

    DEBUGMSGTL(("teraStation:handler", "Processing request (%d)\n",
                reqinfo->mode));

	/* Get the number of existing "/etc/melco/iscsi_disksXXX" */
	f_sum = 0;
#ifdef ZERO_INDEXED_LUNS
	for (i = 0; i <= NUM_NASISCSIINFO_LIMIT; i++){
#else
	for (i = 1; i <= NUM_NASISCSIINFO_LIMIT; i++){
#endif
		snprintf(f_name, sizeof(f_name), FILE_NASISCSIINFO, i);
		if ( !stat(f_name, &st) ){
			f_sum++;
		}
	}
	/* Restore the last-allocated object's pointer
	 * and change the "head" pointer according to the number of 
	 * existed "/etc/melco/iscsi_disksXXX"  */
	nasISCSITable_head = nasISCSITable_saved_head;
	for ( i = NUM_NASISCSIINFO_LIMIT; i > f_sum; i-- ){
		spTemp = nasISCSITable_head->next;
		/* Not rewind to non-existence(NULL) */
		if ( spTemp != NULL){
			nasISCSITable_head = spTemp;
		}
	}
	/* Check whether "/proc/iscsi_target/mib/sess_attr" exists */
	sa_exist = ( !stat(FILE_NASISCSISTATUS, &st) ) ? 1 : 0;

    switch (reqinfo->mode) {
        /* Read-support (also covers GetNext requests) */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct nasISCSITable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

			if (!table_entry) {
				netsnmp_set_request_error(reqinfo, request, SNMP_NOSUCHINSTANCE);
				continue;
			}

			/* All Combinations
			 *        +-----------------+---------+------------------+----------+
			 *        | /etc/melco/     | /proc/iscsi_target/mib/    | Displsy  |
			 *        |  iscsi_disksXXX |   sess_attr                |          |
			 * +------+-----------------+----------------------------+----------+
			 * | No.1 |  Exists         | Both file and values exist |   Yes    |
			 * | No.2 |  Exists         | Exists, but no values      |   Yes    |
			 * | No.3 |  Exists         | Not exist                  |   No     |
			 * | No.4 |  Not exist      | Exists, but no values      |   No     |
			 * | No.5 |  Not exist      | Not exist                  |   No     |
			 * +------+-----------------+----------------------------+----------+ */

			/* Combination No.3, No.4 and No.5 ==> Register the entry as non-existence */
			if ( ( !f_sum && sa_exist ) || ( !f_sum && !sa_exist ) || (f_sum && !sa_exist) ){	
				netsnmp_set_request_error(reqinfo, request, SNMP_NOSUCHINSTANCE);
				continue;
			} else { /* Combination No.1 and No.2 ==> Update the entry ==> Displayed */
				nasISCSITable_updateEntry(table_entry);
			}
	    
            switch (table_info->colnum) {
            case COLUMN_NASISCSINAME:
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
										(u_char *)table_entry->nasISCSIName,
										table_entry->nasISCSIName_len);
                break;
            case COLUMN_NASISCSISTATUS:
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->nasISCSIStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request, SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

#define NASAPI_CMD	"python "
#define NASAPI_PYC	"/usr/local/lib/nasapi/nasapic.pyc"
#define NASAPI_PY	"/usr/local/lib/nasapi/nasapic.py"

#define	GET_SERVICE_STATUS(member)	\
	" -f get_service_status service_name=" #member
#define	PARSE_SERVICE_STATUS(member) "python -c \"import json, sys; " \
    "print json.load(sys.stdin)['result']['service_status']['" #member "']\""

#define	GET_PORTAL_INFO	\
	" -f get_portal_info"
#define	PARSE_RESULT(member)	"python -c \"import json, sys; " \
    "print json.load(sys.stdin)['result']['" #member "']\""

// use [IS_SUPPORTED(func)]
#define GET_COMMAND_OUTPUT(command, buf) do { \
    FILE *p; \
    *buf = '\0'; \
	if ((p = popen("(" command ") 2>/dev/null", "r")) != NULL) { \
        if (fgets(buf, sizeof buf, p) == NULL) \
            *buf = '\0'; \
        pclose(p); \
    } \
} while (0)

// use [GET_SERVICE_STATUS(member)], [GET_PORTAL_INFO]
#define GET_NASAPI_COMMAND_OUTPUT(command, buf) do { \
    FILE *p, *nasapi; \
    *buf = '\0'; \
    char nasapi_cmd[512] = {}; \
    if ((nasapi = fopen(NASAPI_PYC, "r")) != NULL) { \
        sprintf(nasapi_cmd, "( %s%s" command ")  2>/dev/null", NASAPI_CMD, NASAPI_PYC); \
        fclose(nasapi); \
    }else{ \
        sprintf(nasapi_cmd, "( %s%s" command ")  2>/dev/null", NASAPI_CMD, NASAPI_PY); \
    } \
    if ((p = popen(nasapi_cmd, "r")) != NULL) { \
        if (fgets(buf, sizeof buf, p) == NULL) \
            *buf = '\0'; \
        pclose(p); \
    } \
} while (0)

#define CHOMP(buf) do { \
    char *q; \
    for (q = buf + strlen(buf); q > buf && (--q, *q == '\r' || *q == '\n'); ) { \
        *q = '\0'; \
    } \
} while (0)

#define	IS_SUPPORTED(func)  \
	"egrep 'SUPPORT_" #func "=(on|1)$' /etc/nas_feature >/dev/null;" \
	"echo $?"

/** Initializes the nasSystemInformation module */
void
init_nasSystemInformation(void)
{
    const oid nasProductName_oid[] = { 1,3,6,1,4,1,5227,27,1,10,1 };
    const oid nasSerialNumber_oid[] = { 1,3,6,1,4,1,5227,27,1,10,2 };
    const oid nasFWVersionMajor_oid[] = { 1,3,6,1,4,1,5227,27,1,10,3 };
    const oid nasFWVersionMinor_oid[] = { 1,3,6,1,4,1,5227,27,1,10,4 };
    const oid nasIsFWUpdateAvailable_oid[] = { 1,3,6,1,4,1,5227,27,1,10,5 };

  DEBUGMSGTL(("nasSystemInformation", "Initializing\n"));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasProductName", handle_nasProductName,
                               nasProductName_oid, OID_LENGTH(nasProductName_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasSerialNumber", handle_nasSerialNumber,
                               nasSerialNumber_oid, OID_LENGTH(nasSerialNumber_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasFWVersionMajor", handle_nasFWVersionMajor,
                               nasFWVersionMajor_oid, OID_LENGTH(nasFWVersionMajor_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasFWVersionMinor", handle_nasFWVersionMinor,
                               nasFWVersionMinor_oid, OID_LENGTH(nasFWVersionMinor_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasIsFWUpdateAvailable", handle_nasIsFWUpdateAvailable,
                               nasIsFWUpdateAvailable_oid, OID_LENGTH(nasIsFWUpdateAvailable_oid),
                               HANDLER_CAN_RONLY
        ));
}

int
handle_nasProductName(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    char value[259];

    GET_NASAPI_COMMAND_OUTPUT(GET_PORTAL_INFO "|" PARSE_RESULT(product_name), value);
    CHOMP(value);
    value[256] = '\0';

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR, value, strlen(value));
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasProductName\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasSerialNumber(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    char value[259];

    GET_NASAPI_COMMAND_OUTPUT(GET_PORTAL_INFO "|" PARSE_RESULT(serial_number), value);
    CHOMP(value);
    value[256] = '\0';

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR, value, strlen(value));
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasSerialNumber\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasFWVersionMajor(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    char value[259];

    GET_NASAPI_COMMAND_OUTPUT(GET_PORTAL_INFO "|" PARSE_RESULT(fw_version_major), value);
    CHOMP(value);
    value[256] = '\0';

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR, value, strlen(value));
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasFWVersionMajor\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasFWVersionMinor(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    char value[259];

    GET_NASAPI_COMMAND_OUTPUT(GET_PORTAL_INFO "|" PARSE_RESULT(fw_version_minor), value);
    CHOMP(value);
    value[256] = '\0';

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR, value, strlen(value));
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasFWVersionMinor\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasIsFWUpdateAvailable(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_PORTAL_INFO "|" PARSE_RESULT(isUpdateAvailable), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
        value = NASISFIRMWAREUPDATE_UNAVAILABLE;
        break;
    case 1:
        value = NASISFIRMWAREUPDATE_AVAILABLE;
        break;
    default:
        value = NASISFIRMWAREUPDATE_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasIsFWUpdateAvailable\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

/** Initializes the nasServiceStatus module */
void
init_nasServiceStatus(void)
{
    const oid nasServiceStatusSMB_oid[] = { 1,3,6,1,4,1,5227,27,1,11,1 };
    const oid nasServiceStatusDFS_oid[] = { 1,3,6,1,4,1,5227,27,1,11,2 };
    const oid nasServiceStatusAFP_oid[] = { 1,3,6,1,4,1,5227,27,1,11,3 };
    const oid nasServiceStatusFTP_oid[] = { 1,3,6,1,4,1,5227,27,1,11,4 };
    const oid nasServiceStatusSFTP_oid[] = { 1,3,6,1,4,1,5227,27,1,11,5 };
    const oid nasServiceStatusWebAxs_oid[] = { 1,3,6,1,4,1,5227,27,1,11,6 };
    const oid nasServiceStatusNFS_oid[] = { 1,3,6,1,4,1,5227,27,1,11,7 };
    const oid nasServiceStatusRAIDMaintenance_oid[] = { 1,3,6,1,4,1,5227,27,1,11,8 };
    const oid nasServiceStatusiSCSI_oid[] = { 1,3,6,1,4,1,5227,27,1,11,9 };
    const oid nasServiceStatusDLNAServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,10 };
    const oid nasServiceStatusiTunesServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,11 };
    const oid nasServiceStatusSqueezeboxServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,12 };
    const oid nasServiceStatusPrintServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,13 };
    const oid nasServiceStatusWebServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,14 };
    const oid nasServiceStatusMySQLServer_oid[] = { 1,3,6,1,4,1,5227,27,1,11,15 };
    const oid nasServiceStatusWebAxsSync_oid[] = { 1,3,6,1,4,1,5227,27,1,11,16 };
    const oid nasServiceStatusCloudService_oid[] = { 1,3,6,1,4,1,5227,27,1,11,17 };
    const oid nasServiceStatusBitTorrent_oid[] = { 1,3,6,1,4,1,5227,27,1,11,18 };
    const oid nasServiceStatusTeraSearch_oid[] = { 1,3,6,1,4,1,5227,27,1,11,19 };
    const oid nasServiceStatusIpCamera_oid[] = { 1,3,6,1,4,1,5227,27,1,11,20 };
    const oid nasServiceStatusVirusScan_oid[] = { 1,3,6,1,4,1,5227,27,1,11,21 };
    const oid nasServiceStatusSNMP_oid[] = { 1,3,6,1,4,1,5227,27,1,11,22 };
    const oid nasServiceStatusTimeMachine_oid[] = { 1,3,6,1,4,1,5227,27,1,11,23 };
    const oid nasServiceStatusDirectCopy_oid[] = { 1,3,6,1,4,1,5227,27,1,11,24 };
    const oid nasServiceStatusMailNotification_oid[] = { 1,3,6,1,4,1,5227,27,1,11,25 };
    const oid nasServiceStatusWorkingFolder_oid[] = { 1,3,6,1,4,1,5227,27,1,11,26 };

  DEBUGMSGTL(("nasServiceStatus", "Initializing\n"));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusSMB", handle_nasServiceStatusSMB,
                               nasServiceStatusSMB_oid, OID_LENGTH(nasServiceStatusSMB_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusDFS", handle_nasServiceStatusDFS,
                               nasServiceStatusDFS_oid, OID_LENGTH(nasServiceStatusDFS_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusAFP", handle_nasServiceStatusAFP,
                               nasServiceStatusAFP_oid, OID_LENGTH(nasServiceStatusAFP_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusFTP", handle_nasServiceStatusFTP,
                               nasServiceStatusFTP_oid, OID_LENGTH(nasServiceStatusFTP_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusSFTP", handle_nasServiceStatusSFTP,
                               nasServiceStatusSFTP_oid, OID_LENGTH(nasServiceStatusSFTP_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusWebAxs", handle_nasServiceStatusWebAxs,
                               nasServiceStatusWebAxs_oid, OID_LENGTH(nasServiceStatusWebAxs_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusNFS", handle_nasServiceStatusNFS,
                               nasServiceStatusNFS_oid, OID_LENGTH(nasServiceStatusNFS_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusRAIDMaintenance", handle_nasServiceStatusRAIDMaintenance,
                               nasServiceStatusRAIDMaintenance_oid, OID_LENGTH(nasServiceStatusRAIDMaintenance_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusiSCSI", handle_nasServiceStatusiSCSI,
                               nasServiceStatusiSCSI_oid, OID_LENGTH(nasServiceStatusiSCSI_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusDLNAServer", handle_nasServiceStatusDLNAServer,
                               nasServiceStatusDLNAServer_oid, OID_LENGTH(nasServiceStatusDLNAServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusiTunesServer", handle_nasServiceStatusiTunesServer,
                               nasServiceStatusiTunesServer_oid, OID_LENGTH(nasServiceStatusiTunesServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusSqueezeboxServer", handle_nasServiceStatusSqueezeboxServer,
                               nasServiceStatusSqueezeboxServer_oid, OID_LENGTH(nasServiceStatusSqueezeboxServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusPrintServer", handle_nasServiceStatusPrintServer,
                               nasServiceStatusPrintServer_oid, OID_LENGTH(nasServiceStatusPrintServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusWebServer", handle_nasServiceStatusWebServer,
                               nasServiceStatusWebServer_oid, OID_LENGTH(nasServiceStatusWebServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusMySQLServer", handle_nasServiceStatusMySQLServer,
                               nasServiceStatusMySQLServer_oid, OID_LENGTH(nasServiceStatusMySQLServer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusWebAxsSync", handle_nasServiceStatusWebAxsSync,
                               nasServiceStatusWebAxsSync_oid, OID_LENGTH(nasServiceStatusWebAxsSync_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusCloudService", handle_nasServiceStatusCloudService,
                               nasServiceStatusCloudService_oid, OID_LENGTH(nasServiceStatusCloudService_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusBitTorrent", handle_nasServiceStatusBitTorrent,
                               nasServiceStatusBitTorrent_oid, OID_LENGTH(nasServiceStatusBitTorrent_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusTeraSearch", handle_nasServiceStatusTeraSearch,
                               nasServiceStatusTeraSearch_oid, OID_LENGTH(nasServiceStatusTeraSearch_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusIpCamera", handle_nasServiceStatusIpCamera,
                               nasServiceStatusIpCamera_oid, OID_LENGTH(nasServiceStatusIpCamera_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusVirusScan", handle_nasServiceStatusVirusScan,
                               nasServiceStatusVirusScan_oid, OID_LENGTH(nasServiceStatusVirusScan_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusSNMP", handle_nasServiceStatusSNMP,
                               nasServiceStatusSNMP_oid, OID_LENGTH(nasServiceStatusSNMP_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusTimeMachine", handle_nasServiceStatusTimeMachine,
                               nasServiceStatusTimeMachine_oid, OID_LENGTH(nasServiceStatusTimeMachine_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusDirectCopy", handle_nasServiceStatusDirectCopy,
                               nasServiceStatusDirectCopy_oid, OID_LENGTH(nasServiceStatusDirectCopy_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusMailNotification", handle_nasServiceStatusMailNotification,
                               nasServiceStatusMailNotification_oid, OID_LENGTH(nasServiceStatusMailNotification_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nasServiceStatusWorkingFolder", handle_nasServiceStatusWorkingFolder,
                               nasServiceStatusWorkingFolder_oid, OID_LENGTH(nasServiceStatusWorkingFolder_oid),
                               HANDLER_CAN_RONLY
        ));
}

int
handle_nasServiceStatusSMB(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(smb) "|" PARSE_SERVICE_STATUS(smb), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusSMB\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusDFS(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(dfs) "|" PARSE_SERVICE_STATUS(dfs), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusDFS\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusAFP(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(afp) "|" PARSE_SERVICE_STATUS(afp), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusAFP\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusFTP(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(ftp) "|" PARSE_SERVICE_STATUS(ftp), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusFTP\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusSFTP(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(sftp) "|" PARSE_SERVICE_STATUS(sftp), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusSFTP\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusWebAxs(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(webaxs) "|" PARSE_SERVICE_STATUS(webaxs), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusWebAxs\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusNFS(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(nfs) "|" PARSE_SERVICE_STATUS(nfs), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusNFS\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusRAIDMaintenance(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(raidmaintenance) "|" PARSE_SERVICE_STATUS(raidmaintenance), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusRAIDMaintenance\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusiSCSI(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(iscsi) "|" PARSE_SERVICE_STATUS(iscsi), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusiSCSI\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusDLNAServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value, is_supported;
    char buf[256], *end;

    GET_COMMAND_OUTPUT(IS_SUPPORTED(DLNA_SERVER), buf);
    CHOMP(buf);
    is_supported = strtol(buf, &end, 10) == 0;
    if (!(*buf && !*end))
        is_supported = 0;
    if (!is_supported)
        return SNMP_ERR_NOERROR;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(dlna) "|" PARSE_SERVICE_STATUS(dlna), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusDLNAServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusiTunesServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value, is_supported;
    char buf[256], *end;
 
    GET_COMMAND_OUTPUT(IS_SUPPORTED(ITUNES_SERVER), buf);
    CHOMP(buf);
    is_supported = strtol(buf, &end, 10) == 0;
    if (!(*buf && !*end))
        is_supported = 0;
    if (!is_supported)
        return SNMP_ERR_NOERROR;

    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(itunes) "|" PARSE_SERVICE_STATUS(itunes), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusiTunesServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusSqueezeboxServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value, is_supported;
    char buf[256], *end;
 
    GET_COMMAND_OUTPUT(IS_SUPPORTED(SQUEEZEBOX), buf);
    CHOMP(buf);
    is_supported = strtol(buf, &end, 10) == 0;
    if (!(*buf && !*end))
        is_supported = 0;
    if (!is_supported)
        return SNMP_ERR_NOERROR;

    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(squeezebox) "|" PARSE_SERVICE_STATUS(squeezebox), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusSqueezeboxServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusPrintServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(printserver) "|" PARSE_SERVICE_STATUS(printserver), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusPrintServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusWebServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(webserver) "|" PARSE_SERVICE_STATUS(webserver), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusWebServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusMySQLServer(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(mysql) "|" PARSE_SERVICE_STATUS(mysql), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusMySQLServer\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusWebAxsSync(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(webaxssync) "|" PARSE_SERVICE_STATUS(webaxssync), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusWebAxsSync\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusCloudService(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(cloudservice) "|" PARSE_SERVICE_STATUS(cloudservice), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusCloudService\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusBitTorrent(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value, is_supported;
    char buf[256], *end;
 
    GET_COMMAND_OUTPUT(IS_SUPPORTED(BITTORRENT), buf);
    CHOMP(buf);
    is_supported = strtol(buf, &end, 10) == 0;
    if (!(*buf && !*end))
        is_supported = 0;
    if (!is_supported)
        return SNMP_ERR_NOERROR;

    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(bittorrent) "|" PARSE_SERVICE_STATUS(bittorrent), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusBitTorrent\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusTeraSearch(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(terasearch) "|" PARSE_SERVICE_STATUS(terasearch), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusTeraSearch\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusIpCamera(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(ipcamera) "|" PARSE_SERVICE_STATUS(ipcamera), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusIpCamera\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusVirusScan(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(virusscan) "|" PARSE_SERVICE_STATUS(virusscan), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusVirusScan\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusSNMP(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(snmp) "|" PARSE_SERVICE_STATUS(snmp), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusSNMP\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusTimeMachine(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(timemachine) "|" PARSE_SERVICE_STATUS(timemachine), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusTimeMachine\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusDirectCopy(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(directcopy) "|" PARSE_SERVICE_STATUS(directcopy), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusDirectCopy\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusMailNotification(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value;
    char buf[256], *end;
 
    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(mailnotification) "|" PARSE_SERVICE_STATUS(mailnotification), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusMailNotification\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_nasServiceStatusWorkingFolder(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int nasapi_value, value, is_supported;
    char buf[256], *end;
 
    GET_COMMAND_OUTPUT(IS_SUPPORTED(WORKINGFOLDER), buf);
    CHOMP(buf);
    is_supported = strtol(buf, &end, 10) == 0;
    if (!(*buf && !*end))
        is_supported = 0;
    if (!is_supported)
        return SNMP_ERR_NOERROR;

    GET_NASAPI_COMMAND_OUTPUT(GET_SERVICE_STATUS(workingfolder) "|" PARSE_SERVICE_STATUS(workingfolder), buf);
    CHOMP(buf);
    nasapi_value = strtol(buf, &end, 10);
    if (!(*buf && !*end))
        nasapi_value = -1;
 
    switch (nasapi_value) {
    case 0:
    case 2:
        value = NASSERVICESTATUS_OFF;
        break;
    case 1:
    case 3:
        value = NASSERVICESTATUS_ON;
        break;
    default:
        value = NASSERVICESTATUS_UNKNOWN;
        break;
    }

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, &value, sizeof value);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nasServiceStatusWorkingFolder\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
